
import java.util.Stack;
import java.util.StringTokenizer;
import java.util.Calendar;
import java.util.Locale;
import java.util.ResourceBundle;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Font;
import javax.swing.JTextArea;
import java.awt.image.BufferedImage;
import javax.imageio.*;
import java.io.*;
import javax.swing.JOptionPane;
import javax.swing.ImageIcon;
import javax.swing.Icon;
import java.math.BigDecimal;

public class LancePrimitive {
	Cadre cadre;
	Procedure procedure;
	static final BigDecimal un=new BigDecimal(1);
	static final BigDecimal zero=new BigDecimal(0);
	String debut_chaine = "";

	// Ceci est le dbut de la chaine gnrique renvoy par les primitives
	// Elle vaut "\"" pour les mots et "" pour les nombres
	public LancePrimitive(Cadre cadre) {
		this.cadre = cadre;
	}
	void execute(int id, Stack param) {
		//identifiant procdure ou primitive, valeur des paramtres
		if (id < 0) {
			procedure = (Procedure) cadre.primitive.procedure.get(-id - 2);
			Interprete.stockvariable.push(Interprete.locale);
			Interprete.stockvariable.push(Interprete.valeur);
			Interprete.locale = (Stack) procedure.variable.clone();
			Interprete.valeur = param;
			if (Cadre.mode_trace) {
				StringBuffer buffer=new StringBuffer();
				for(int i=0;i<Interprete.en_cours.size();i++) buffer.append("  ");
				buffer.append(procedure.name);
				for (int i=0;i<param.size();i++) buffer.append(" "+SortieTexte(param.get(i).toString()));
				String msg=buffer + "\n";
				cadre.panneauHistorique1.ecris("normal", msg);
			}
			Interprete.en_cours.push(procedure.name);
			if (Interprete.instruction.length()==0)
				Interprete.instruction.append(procedure.instr + "\n ");
			else {
				Interprete.instruction.insert(0, procedure.instr + "\n ");
			}
			Interprete.nom.push("\n");
		} else {
			switch (id) {
			case 0: //av
				delay();
				try {
					cadre.primitive.av(nombre(param.pop()));
				} catch (monException e) {
				}
				break;
			case 1: //re
				delay();
				try {
					cadre.primitive.av(-nombre(param.pop()));
				} catch (monException e) {
				}
				break;
			case 2: //td
				delay();
				try {
					cadre.primitive.td(nombre(param.pop()));
				} catch (monException e) {
				}
				break;
			case 3: //tg
				delay();
				try {
					cadre.primitive.td(-nombre(param.pop()));

				} catch (monException e) {
				}
				break;
			case 4: //puissance
				try {
					double p = Math.pow((double) nombre(param.get(0)),
							(double) nombre(param.get(1)));
					Interprete.calcul.push(teste_fin_double(p));
					Interprete.operande = true;
				} catch (monException e) {
				}
				break;
			case 5: //repete
				try {
					String liste = liste(param.get(1).toString());
					cadre.primitive.repete(entier(param.get(0)), liste);
				} catch (monException e) {
				}
				break;
			case 6: //ve
				cadre.primitive.videecran();
				break;
			case 7: //ct
				if (cadre.tortue.visible) {
					cadre.primitive.ct_mt();
					cadre.tortues_visibles.remove(String
							.valueOf(cadre.tortue.id));
				}
				cadre.tortue.visible = false;
				break;
			case 8: //mt
				if (!cadre.tortue.visible) {
					cadre.primitive.ct_mt();
					cadre.tortues_visibles
							.push(String.valueOf(cadre.tortue.id));
				}
				cadre.tortue.visible = true;
				break;
			case 9: //ecris, ec
				String par = param.get(0).toString().trim();
				if (estliste(par))
					par = EcrireListe(par.substring(1, par.length() - 1));
				String mot = mot(param.get(0));
				if (null == mot)
					cadre.panneauHistorique1.ecris("perso", SortieTexte(par) + "\n");
				else
					cadre.panneauHistorique1.ecris("perso", SortieTexte(mot) + "\n");
				break;
			case 10: //si
				try {
					String liste = liste(param.get(1).toString());
					liste=new String(Cadre.decoupe(liste));
					String liste2 = null;
					boolean predicat = predicat(param.get(0).toString());
					if (Interprete.instruction.length()!=0) {
						try {
							if (Interprete.instruction.charAt(0)=='[') {
								Interprete.enleve("[");
								liste2 = liste(cadre.interprete.chercheListe());
								liste2=new String(Cadre.decoupe(liste2));
							}
						} catch (Exception e) {
						}
					}
					cadre.primitive.si(predicat, liste, liste2);
					Interprete.renvoi_instruction=true;
				} catch (monException e) {
				}
				break;
			case 11: // STOP
				cadre.primitive.stop();
				break;
			case 12: //origine
				delay();
				try {
					cadre.primitive.fpos("0 0");
				} catch (monException e) {
				}
				if (cadre.tortue.visible)
					cadre.primitive.montrecacheTortue();
				cadre.tortue.cap = 0;
				cadre.tortue.angle = Math.PI / 2;
				if (cadre.tortue.visible)
					cadre.primitive.montrecacheTortue();
				break;
			case 13: //fpos
				delay();
				try {
					cadre.primitive.fpos(liste(param.get(0).toString()));
				} catch (monException e) {
				}
				break;
			case 14: //fixex
				delay();
				try {
					double x = nombre(param.get(0));
					double y = Logo.hauteur_dessin/2 - cadre.tortue.corY;
					cadre.primitive.fpos(x + " " + y);
				} catch (monException e) {
				}
				break;
			case 15: //fixey
				delay();
				try {
					double y = nombre(param.get(0));
					double x = cadre.tortue.corX - Logo.largeur_dessin/2;
					cadre.primitive.fpos(x + " " + y);
				} catch (monException e) {
				}
				break;
			case 16: //fixexy
				delay();
				try {
					cadre.primitive.fpos(nombre(param.get(0).toString()) + " "
							+ nombre(param.get(1).toString()));
				} catch (monException e) {
				}
				break;
			case 17: // fixecap
				delay();
				try {
					cadre.primitive.td(360 - cadre.tortue.cap
							+ nombre(param.pop().toString()));
				} catch (monException e) {
				}
				break;
			case 18: //lc
				cadre.tortue.baissecrayon = false;
				break;
			case 19: //bc
				cadre.tortue.baissecrayon = true;
				break;
			case 20: //gomme
				cadre.tortue.baissecrayon = true;
				cadre.tortue.couleurmodedessin = cadre.tortue.couleurcrayon;
				cadre.tortue.couleurcrayon = cadre.couleurfond;
				break;
			case 21: // inversecrayon
				cadre.tortue.baissecrayon = true;
				cadre.tortue.inversecrayon = true;
				break;
			case 22: //dessine
				cadre.tortue.inversecrayon = false;
				cadre.tortue.baissecrayon = true;
				cadre.tortue.couleurcrayon = cadre.tortue.couleurmodedessin;
				break;
			case 23: //somme
				try {
					BigDecimal a = nombre_precis(param.get(0));
					BigDecimal b = nombre_precis(param.get(1));
					Interprete.calcul.push(a.add(b).toString());
					Interprete.operande = true;
				} catch (monException e) {
				}
				break;
			case 24: //difference
				try {
					BigDecimal a = nombre_precis(param.get(0));
					BigDecimal b = nombre_precis(param.get(1));
					Interprete.calcul.push(a.subtract(b).toString());
					Interprete.operande = true;
				} catch (monException e) {
				}
				break;
			case 25: //moins (oppos)
				try {
					BigDecimal a = nombre_precis(param.get(0));
					Interprete.calcul.push(a.negate().toString());
					Interprete.operande = true;
				} catch (monException e) {
				}
				break;
			case 26: //produit
				try {
					BigDecimal a = nombre_precis(param.get(0));
					BigDecimal b = nombre_precis(param.get(1));
					Interprete.calcul.push(a.multiply(b).toString());
					Interprete.operande = true;
				} catch (monException e) {
				}
				break;
			case 27: //div
				try {
					double a = nombre(param.get(0));
					double b = nombre(param.get(1));
					if (b == 0)
						throw new monException(cadre, Logo.messages
								.getString("division_par_zero"));
					Interprete.calcul.push(teste_fin_double(a / b));
					Interprete.operande = true;
				} catch (monException e) {
				}
				break;
			case 28: //reste
				try {
					long a = entier(param.get(0));
					long b = entier(param.get(1));
					if (b == 0)
						throw new monException(cadre, Logo.messages
								.getString("division_par_zero"));
					Interprete.calcul.push(teste_fin_double(a % b));
					Interprete.operande = true;
				} catch (monException e) {
				}
				break;
			case 29: //retourne
				try {
					cadre.primitive.retourne(param.get(0).toString());
				} catch (monException e) {
				}
				break;
			case 30: // *
				try {
					BigDecimal a = nombre_precis(param.get(0));
					BigDecimal b = nombre_precis(param.get(1));
					Interprete.calcul.push(a.multiply(b).toString());
					Interprete.operande = true;
				} catch (monException e) {
				}
				break;
			case 31: // diviser /
				try {
					double a = nombre(param.get(0));
					double b = nombre(param.get(1));
					if (b == 0)
						throw new monException(cadre, Logo.messages
								.getString("division_par_zero"));
					Interprete.calcul.push(teste_fin_double(a / b));
					Interprete.operande = true;
				} catch (monException e) {
				}
				break;
			case 32: // +
				try {
					BigDecimal a = nombre_precis(param.get(0));
					BigDecimal b = nombre_precis(param.get(1));
					Interprete.calcul.push(a.add(b).toString());
					Interprete.operande = true;
				} catch (monException e) {
				}
				break;
			case 33: // -
				try {
					BigDecimal a = nombre_precis(param.get(0));
					BigDecimal b = nombre_precis(param.get(1));
					Interprete.calcul.push(a.subtract(b));
					Interprete.operande = true;
				} catch (monException e) {
				}
				break;
			case 34: // =
				egal(param);
				break;
			case 35: // <
				try {
					double a = nombre(param.get(0));
					double b = nombre(param.get(1));
					if (a < b)
						Interprete.calcul.push(Logo.messages.getString("vrai"));
					else
						Interprete.calcul.push(Logo.messages.getString("faux"));
				} catch (monException e) {
				}
				Interprete.operande = true;
				break;
			case 36: // >
				try {
					double a = nombre(param.get(0));
					double b = nombre(param.get(1));
					if (a > b)
						Interprete.calcul.push(Logo.messages.getString("vrai"));
					else
						Interprete.calcul.push(Logo.messages.getString("faux"));
				} catch (monException e) {
				}
				Interprete.operande = true;
				break;
			case 37: // |
				try {
					boolean b1 = predicat(param.get(0).toString());
					boolean b2 = predicat(param.get(1).toString());
					b1 = b1 | b2;
					if (b1)
						Interprete.calcul.push(Logo.messages.getString("vrai"));
					else
						Interprete.calcul.push(Logo.messages.getString("faux"));
				} catch (monException e) {
				}
				Interprete.operande = true;
				break;
			case 38: // &
				try {
					boolean b1 = predicat(param.get(0).toString());
					boolean b2 = predicat(param.get(1).toString());
					b1 = b1 & b2;
					if (b1)
						Interprete.calcul.push(Logo.messages.getString("vrai"));
					else
						Interprete.calcul.push(Logo.messages.getString("faux"));
				} catch (monException e) {
				}
				Interprete.operande = true;
				break;
			case 39: //oprateur interne \n signalant une fin de procdure
				if (!Interprete.en_cours.isEmpty())
					{Interprete.en_cours.pop();
					}
				Interprete.valeur = (Stack) Interprete.stockvariable.pop();
				Interprete.locale = (Stack) Interprete.stockvariable.pop();
				if (Interprete.nom.peek().equals("\n"))
					Interprete.nom.pop();
				else {
					try {
						throw new monException(cadre, Logo.messages
								.getString("pas_assez_de")
								+ " " + Interprete.nom.peek());
					} catch (monException e) {
					}
				}
				break;
			case 40: // oprateur interne \ signalant une fin de boucle
				 // Si c'est repete
				BoucleParametre bp=((BoucleParametre)Primitive.pile_iteration.peek());
				String idb=bp.getId();
				if (idb.equals("repete")){
					BigDecimal compteur=bp.getCompteur();
					BigDecimal fin=bp.getFin();
					if (compteur.compareTo(fin) < 0) {
						bp.incremente();
						Primitive.pile_iteration.pop();
						Primitive.pile_iteration.push(bp);
						Interprete.instruction.insert(0, bp.getInstr()+ "\\ ");	
					}
					else if (compteur.compareTo(fin)==0){
						Primitive.pile_iteration.pop();
					}
				} 
				else if (idb.equals("repetepour")) { // si c'est repetepour
					BigDecimal inc=bp.getIncrement();
					BigDecimal compteur=bp.getCompteur();
					BigDecimal fin=bp.getFin();
					
					if ((inc.compareTo(zero)==1&& (compteur.add(inc).compareTo(fin) <=0))||(inc.compareTo(zero)==-1&&(compteur.add(inc).compareTo(fin)>=0))){
						bp.incremente();
						bp.AffecteVar(false);
						Primitive.pile_iteration.pop();
						Primitive.pile_iteration.push(bp);
						Interprete.instruction.insert(0, bp.getInstr()+ "\\ ");			
					}
					else {
						bp.DeleteVar();
						Primitive.pile_iteration.pop();
					}
				}
				break;
			case 41: //pos
				Interprete.operande = true;
				long a = Math.round(cadre.tortue.corX - Logo.largeur_dessin/2);
				long b = Math.round(Logo.hauteur_dessin/2 - cadre.tortue.corY);
				Interprete.calcul.push("[" + a + " " + b + "]");
				break;
			case 42: //cap
				Interprete.operande = true;
				Interprete.calcul.push(teste_fin_double(cadre.tortue.cap));
				break;
			case 43: //arrondi
				Interprete.operande = true;
				try {
					Interprete.calcul.push(String.valueOf(Math
							.round(nombre(param.get(0)))));
				} catch (monException e) {
				}
				break;
			case 44: //log10
				Interprete.operande = true;
				try {
					double nombre = nombre(param.get(0));
					if (nombre < 0 || nombre == 0) {
						Locale locale = Logo.genere_locale(Logo.langage);
						ResourceBundle prim = ResourceBundle.getBundle(
								"primitives", locale);
						String cle = cadre.primitive.primitive[44];
						cle = prim.getString(cle);
						StringTokenizer str = new StringTokenizer(cle);
						String log = "";
						while (str.hasMoreTokens()) {
							log = str.nextToken();
						}
						throw new monException(cadre, log + " "
								+ Logo.messages.getString("attend_positif"));
					}
					Interprete.calcul.push(teste_fin_double(Math.log(nombre)
							/ Math.log(10)));
				} catch (monException e) {
				}
				break;
			case 45: //sin
				try {
					Interprete.calcul.push(teste_fin_double(Math.sin(Math
							.toRadians(nombre(param.get(0))))));
				} catch (monException e) {
				}
				Interprete.operande = true;
				break;
			case 46: //cos
				try {
					Interprete.calcul.push(teste_fin_double(Math.cos(Math
							.toRadians(nombre(param.get(0))))));
				} catch (monException e) {
				}
				Interprete.operande = true;
				break;
			case 47: //ou
				try {
					boolean b1 = predicat(param.get(0).toString());
					boolean b2 = predicat(param.get(1).toString());
					b1 = b1 | b2;
					if (b1)
						Interprete.calcul.push(Logo.messages.getString("vrai"));
					else
						Interprete.calcul.push(Logo.messages.getString("faux"));
					Interprete.operande = true;
				} catch (monException e) {
				}
				break;
			case 48: //et
				try {
					boolean b1 = predicat(param.get(0).toString());
					boolean b2 = predicat(param.get(1).toString());
					b1 = b1 & b2;
					Interprete.operande = true;
					if (b1)
						Interprete.calcul.push(Logo.messages.getString("vrai"));
					else
						Interprete.calcul.push(Logo.messages.getString("faux"));
				} catch (monException e) {
				}
				break;
			case 49: //non
				try {
					Interprete.operande = true;
					boolean b1 = predicat(param.get(0).toString());
					if (b1)
						Interprete.calcul.push(Logo.messages.getString("faux"));
					else
						Interprete.calcul.push(Logo.messages.getString("vrai"));
				} catch (monException e) {
				}
				break;
			case 50: //liste
				String liste = "[ ";
				Interprete.operande = true;
				String mot2 = param.get(0).toString();
				mot = mot(param.get(0));
				if (null == mot)
					liste += mot2;
				else {
					if (mot.equals("")) mot="\\v";
					liste += mot + " ";
				}
				mot2 = param.get(1).toString();
				mot = mot(param.get(1));
				if (null == mot)
					liste += param.get(1).toString() + " ";
				else {
					if (mot.equals("")) mot="\\v";
					liste += mot + " ";
				}
				Interprete.calcul.push(liste + "] ");
				break;
			case 51: //phrase
				liste = "[ ";
				Interprete.operande = true;
				for (int i = 0; i < 2; i++) {
					mot = mot(param.get(i));
					mot2 = param.get(i).toString().trim();
					if (null == mot) {
						if (estliste(mot2))
							liste += mot2.substring(1, mot2.length() - 1)
									.trim()
									+ " ";
						else
							liste += mot2 + " ";
					} else
						{	if (mot.equals("")) mot="\\v"; 
							liste += mot + " ";
						}
				}
				Interprete.calcul.push(liste.trim() + "] ");
				break;
			case 52: //metspremier
				try {
					liste = liste(param.get(1).toString());
					Interprete.operande = true;
					mot = mot(param.get(0));
					if (null!=mot&& mot.equals("")) mot="\\v";
					if (null == mot)
						Interprete.calcul.push("[ "
								+ param.get(0).toString().trim() + " "
								+ liste.trim() + " ] ");
					else{
						Interprete.calcul.push("[ " + mot + " " + liste.trim()
								+ " ] ");}
				} catch (monException e) {
				}
				break;
			case 53: //metsdernier
				try {
					liste = liste(param.get(1).toString()).trim();
					Interprete.operande = true;
					mot = mot(param.get(0));
					if (null!=mot && mot.equals("")) mot="\\v";
					if (null == mot){ // Si c'est une liste
							Interprete.calcul.push(("[ " + liste).trim() + " "
								+ param.get(0).toString().trim() + " ] ");
						
					} 
					else
						Interprete.calcul.push(("[ " + liste).trim() +" "+mot+" ] ");
				} catch (monException e) {
				}
				break;
			case 54: // inverse liste
				try {
					liste = liste(param.get(0).toString()).trim();
					Interprete.operande = true;
					StringTokenizer st = new StringTokenizer(liste);
					liste = " ] ";
					String element = "";
					while (st.hasMoreTokens()) {
						element = st.nextToken();
						if (element.equals("["))
							element = ExtraitListe(st);
						liste = " " + element + liste;
					}
					Interprete.calcul.push("[" + liste);
				} catch (monException e) {
				}
				break;
			case 55: //choix
				Interprete.operande = true;
				mot = mot(param.get(0));
				if (null == mot) {
					try {
						liste = liste(param.get(0).toString());
						StringTokenizer st = new StringTokenizer(liste);
						int nombre = (int) Math.floor(NombreElement(liste)
								* Math.random()) + 1;
						String tmp=item(liste, nombre);
						if (tmp.equals("\"\\v")) tmp="\"";
						Interprete.calcul.push(tmp);
					} catch (monException e) {
					}
				} else {
					int nombre = (int) Math.floor(Math.random() * compte_mot(mot))+1;
					String st="";
					try{
						st=item_mot(nombre,mot);
						Double.parseDouble(st);
						Interprete.calcul.push(st);
					}
					catch(NumberFormatException e1){
						Interprete.calcul.push(debut_chaine+ st);}
					catch(monException e2){}
					} 
				break;
			case 56: //enleve
				Interprete.operande = true;
				try {
					liste = liste(param.get(1).toString());
					StringTokenizer st = new StringTokenizer(liste);
					liste = "[ ";
					mot = mot(param.get(0));
					String str;
					if(null!=mot&&mot.equals("")) mot="\\v";
					if (null == mot)
						mot = param.get(0).toString().trim();
					
					while (st.hasMoreTokens()) {
						str = st.nextToken();
						if (str.equals("["))
							str = ExtraitListe(st);
						if (!str.equals(mot))
							liste += str + " ";
					}
					Interprete.calcul.push(liste.trim() + " ] ");
				} catch (monException e) {
				}
				break;
			case 57: //item
				Interprete.operande = true;
				try {
					mot = mot(param.get(1).toString());
					if (null == mot)
						Interprete.calcul.push(item(liste(param.get(1)
								.toString()), entier(param.get(0))));
					else {
						long i = entier(param.get(0));
						if (i < 1 || i > compte_mot(mot))
							throw new monException(cadre, "item n'aime pas "
									+ i + " comme argument pour le mot " + mot
									+ ".");
						else{
							String st= item_mot((int)i,mot);
							try{
								Double.parseDouble(st);
								Interprete.calcul.push(st);
							}
							catch(NumberFormatException e1){
								Interprete.calcul.push(debut_chaine+st);
							}
						}
					}
				} catch (monException e) {
				}
				break;
			case 58: //saufdernier
				Interprete.operande = true;
				mot = mot(param.get(0));
				if (null == mot) {
					try {
						liste = liste(param.get(0).toString()).trim();
						String element = item(liste, NombreElement(liste));
						int longueur = element.length();
						if (element.startsWith("\""))
							longueur--;
						Interprete.calcul.push("[ "
								+ liste.substring(0, liste.length() - longueur)
								+ "]");
					} catch (monException e) {
					}
				} 
				else if(mot.equals("")) {
					try{
					throw new monException(cadre,Logo.messages.getString("mot_vide"));}
				catch(monException e1){}	
				} 
				else if (compte_mot(mot) == 1)
					Interprete.calcul.push("\"");
				else {
					String tmp=mot.substring(0, mot.length() - 1);
					if (tmp.endsWith("\\")) tmp=tmp.substring(0, tmp.length() - 1);
					try{
						Double.parseDouble(tmp);
						Interprete.calcul.push(tmp );						
					}
					catch(NumberFormatException e){
						Interprete.calcul.push(debut_chaine+tmp );
					}
				}
				break;
			case 59: //saufpremier
				Interprete.operande = true;
				mot = mot(param.get(0));
				if (null == mot) {
					try {
						liste = liste(param.get(0).toString()).trim();
						String element = item(liste, 1);
						int longueur = element.length();
						if (element.startsWith("\""))
							longueur--;
						Interprete.calcul.push("["
								+ liste.substring(longueur, liste.length())
								+ " ] ");
					} catch (monException e) {
					}
				} 
				else if(mot.equals("")) {
					try{
					throw new monException(cadre,Logo.messages.getString("mot_vide"));}
				catch(monException e1){}	
				} 
				else if (compte_mot(mot) == 1)
					Interprete.calcul.push("\"");
				else {
					if (!mot.startsWith("\\")) mot=mot.substring(1);
					else mot=mot.substring(2);
					try{ 
						Double.parseDouble(mot);
						Interprete.calcul.push(mot);}
					catch(NumberFormatException e){
						Interprete.calcul.push(debut_chaine + mot);
					}
				}
				break;
			case 60: //dernier
				Interprete.operande = true;
				mot = mot(param.get(0));
				if (null == mot) { // Si c'est une liste
					try {
						liste = liste(param.get(0).toString());
						Interprete.calcul
								.push(item(liste, NombreElement(liste)));
					} catch (monException e) {
					}
				} else if (compte_mot(mot) == 1)
					Interprete.calcul.push(debut_chaine + mot);
				else {
					String st="";
					try{
						st=item_mot(compte_mot(mot),mot);
						Double.parseDouble(st);
						Interprete.calcul.push(st);
					}
					catch(NumberFormatException e1){
						Interprete.calcul.push(debut_chaine + st);
					}
					catch(monException e2){}
				} 
				break;
			case 61: //premier
				Interprete.operande = true;
				mot = mot(param.get(0));
				if (null == mot) { //SI c'est une liste
					try {
						liste = liste(param.get(0).toString());
						Interprete.calcul.push(item(liste, 1));
					} catch (monException e) {
					}
				} else if (compte_mot(mot) == 1)
					Interprete.calcul.push(debut_chaine + mot);	
				else{
					String st="";
					try{
						st=item_mot(1,mot);
						Double.parseDouble(st);
						Interprete.calcul.push(st);
					}
					catch(monException e1){}
					catch(NumberFormatException e2){
						Interprete.calcul.push(debut_chaine + st);	
					}
				}
				break;
			case 62: //compte
				Interprete.operande = true;
				mot = mot(param.get(0));
				if (null == mot) {
					try {
						liste = liste(param.get(0).toString());
						Interprete.calcul.push(String
								.valueOf(NombreElement(liste)));
					} catch (monException e) {
					}
				} else
					Interprete.calcul.push(String.valueOf(compte_mot(mot)));
				break;
			case 63: //mot?
				mot = mot(param.get(0));
				if (null == mot)
					Interprete.calcul.push(Logo.messages.getString("faux"));
				else
					Interprete.calcul.push(Logo.messages.getString("vrai"));
				Interprete.operande = true;
				break;
			case 64: //nombre?
				try {
					Double.parseDouble(param.get(0).toString());
					Interprete.calcul.push(Logo.messages.getString("vrai"));
				} catch (NumberFormatException e) {
					Interprete.calcul.push(Logo.messages.getString("faux"));
				}
				Interprete.operande = true;
				break;
			case 65: //liste?
				liste = param.get(0).toString().trim();
				if (estliste(liste))
					Interprete.calcul.push(Logo.messages.getString("vrai"));
				else
					Interprete.calcul.push(Logo.messages.getString("faux"));
				Interprete.operande = true;
				break;
			case 66: //vide?
				liste = param.get(0).toString().trim();
				mot = mot(param.get(0));
				if (null == mot) { //si c'est une liste ou un nombre
					try {
						liste = liste(liste).trim();
						if (liste.equals(""))
							Interprete.calcul.push(Logo.messages
									.getString("vrai"));
						else
							Interprete.calcul.push(Logo.messages
									.getString("faux"));
					} catch (monException e) {
					}
				} else { // Si c'est un mot
					if (mot.equals(""))
						Interprete.calcul.push(Logo.messages.getString("vrai"));
					else
						Interprete.calcul.push(Logo.messages.getString("faux"));
				}
				Interprete.operande = true;
				break;
			case 67: //egal?
				egal(param);
				break;
			case 68: //precede?
				try {
					precede(param);
				} catch (monException e) {
				}
				break;
			case 69: //membre ?
				try {
					membre(param, id);
				} catch (monException e) {
				}
				break;
			case 70: //racine
				Interprete.operande = true;
				try {
					double nombre = nombre(param.get(0));
					if (nombre < 0) {
						Locale locale = Logo.genere_locale(Logo.langage);
						ResourceBundle prim = ResourceBundle.getBundle(
								"primitives", locale);
						String cle = cadre.primitive.primitive[70];
						cle = prim.getString(cle);
						StringTokenizer str = new StringTokenizer(cle);
						String racine = "";
						while (str.hasMoreTokens()) {
							racine = str.nextToken();
						}
						throw new monException(cadre, racine + " "
								+ Logo.messages.getString("attend_positif"));
					}
					Interprete.calcul.push(teste_fin_double(Math.sqrt(nombre)));
				} catch (monException e) {
				}
				break;
			case 71: //membre
				try {
					membre(param, id);
				} catch (monException e) {
				}
				break;
			case 72: //donne
				try {
					donne(param);
					Interprete.operande=false;
				} catch (monException e) {
				}
				
				break;
			case 73: //locale
				try {
					locale(param);
					Interprete.operande=false;
				} catch (monException e) {
				}
				break;
			case 74: //donnelocale
				try {
					locale(param);
					donne(param);
					Interprete.operande=false;
				} catch (monException e) {
				}
				break;
			case 75: //fcc
				try {
					fcc(param);
				} catch (monException e) {
				}
				break;
			case 76: //fcfg
				try {
					fcfg(param);
				} catch (monException e) {
				}
				break;
			case 77: //hasard
				Interprete.operande = true;
				try {
					long i = entier(param.get(0));
					i = (int) Math.floor(Math.random() * i);
					Interprete.calcul.push(String.valueOf(i));
				} catch (monException e) {
				}
				break;
			case 78: //attends
				try {
					long temps = entier(param.get(0));
					int nbsecondes = (int) (temps / 60);
					long reste = temps % 60;
					for (int i = 0; i < nbsecondes; i++) {
						Thread.sleep(1000);
						if (cadre.error)
							break;
					}
					if (!cadre.error)
						Thread.sleep(reste*50/3);
				} catch (monException e1) {
				} catch (InterruptedException e2) {
				}
				break;
			case 79: //imts
				for (int i = 0; i < cadre.primitive.procedure.size(); i++) {
					Procedure proc = (Procedure) cadre.primitive.procedure
							.get(i);
					if (proc.affichable)
						cadre.panneauHistorique1.ecris("commentaire", proc.name
								+ "\n");
				}
				break;
			case 80: //effacenom
				String nom = mot(param.get(0));
				for (int i = 0; i < cadre.primitive.procedure.size(); i++) {
					Procedure procedure = (Procedure) cadre.primitive.procedure
							.get(i);
					if (procedure.name.equals(nom)
							&& procedure.affichable == true) {
						cadre.primitive.nbproc--;
						cadre.primitive.procedure.remove(i);
						break;
					}
				}
				break;
			case 81: //effacevariable
				mot = mot(param.get(0));
				if (!Interprete.locale.isEmpty()) {
					int index = Interprete.locale.search(mot);
					if (index != -1) {
						Interprete.locale.remove(index - 1);
						Interprete.valeur.remove(index - 1);
					}
				} else {
					int index = Cadre.globale.search(mot);
					if (index != -1) {
						Cadre.globale.remove(index - 1);
						Cadre.valeur.remove(index - 1);
					}
				}
				break;
			case 82: //effacenoms,efns
				for (int i = cadre.primitive.nbproc - 1; i > -1; i--) {
					Procedure procedure = (Procedure) cadre.primitive.procedure
							.get(i);
					if (procedure.affichable == true)
						cadre.primitive.procedure.remove(i);
				}
				cadre.primitive.nbproc = cadre.primitive.procedure.size();
				Cadre.globale = new Stack();
				Cadre.valeur = new Stack();
				cadre.jMenuFileNouveau.setEnabled(false);
				break;
			case 83: //mot
				Interprete.operande = true;
				String debut = "";
				mot = mot(param.get(0));
				debut += debut_chaine;
				mot2 = mot(param.get(1));
				if (null == mot || null == mot2) { //Si l'un des arguments est
												   // une liste
					String faute = "";
					if (null == mot)
						faute = param.get(0).toString();
					else
						faute = param.get(1).toString();
					try {
						throw new monException(cadre, faute + " "
								+ Logo.messages.getString("doit_etre_mot"));
					} catch (monException e) {
					}
					;
				}
				if (debut.equals("")) {
					debut += debut_chaine;
				} // Si les deux arguments ne sont pas des nombres
				String resultat=debut+mot+mot2;
				if (resultat.equals("")) resultat="\"";
				Interprete.calcul.push(resultat);
				break;
			case 84: //etiquette
				par = param.get(0).toString().trim();
				if (estliste(par))
					par = EcrireListe(par.substring(1, par.length() - 1));
				mot = mot(param.get(0));
				if (null == mot)
					cadre.primitive.etiquette(SortieTexte(par));
				else
					cadre.primitive.etiquette(SortieTexte(mot));
				break;
			case 85: ///trouvecouleur
				if (cadre.tortue.visible)
					cadre.primitive.montrecacheTortue();
				try {
					Color r = trouvecouleur(param.get(0));

					Interprete.operande = true;
					Interprete.calcul.push("[" + r.getRed() + " "
							+ r.getGreen() + " " + r.getBlue() + "]");
				} catch (monException e) {
				}
				if (cadre.tortue.visible)
					cadre.primitive.montrecacheTortue();
				break;
			case 86: //fenetre
				Cadre.etat_fenetre = 0;
				break;
			case 87: //enroule
				Cadre.etat_fenetre = 1;
				break;
			case 88: //clos
				Cadre.etat_fenetre = 2;
				break;
			case 89: // videtexte
				cadre.panneauHistorique1.vide_texte();
				break;
			case 90: // chargeimage
				BufferedImage image = null;
				try {
					image = testechemin(param.get(0).toString());
				} catch (monException e) {
				}
				if (null != image)
					cadre.primitive.chargeimage(image);
				break;
			case 91: //ftc, fixetaillecrayon
				try {
					double nombre = nombre(param.get(0));
					if (nombre < 0)
						nombre = Math.abs(nombre);

					cadre.tortue.fixe_taille_crayon((float) nombre);
					cadre.primitive.g.setStroke(cadre.tortue.crayon);
				} catch (monException e) {
				}
				break;
			case 92: //tantque
				try {
					String li1 = liste(param.get(0).toString());
					li1=new String(Cadre.decoupe(li1));
					String li2 = liste(param.get(1).toString());
					li2=new String(Cadre.decoupe(li2));
					String instr="siwhile "+li1+ "[ " + li2+ "] ";
					bp=new BoucleParametre(un,zero,un,instr,"tantque");
					Primitive.pile_iteration.push(bp);
					Interprete.instruction.insert(0, instr+"\\ ");
				} catch (monException e) {
				}

				break;
			case 93: //lis
				try {
					liste = liste(param.get(0).toString());
					mot = mot(param.get(1));
					if (null == mot)
						throw new monException(cadre, Logo.messages
								.getString("erreurmot"));
					java.awt.FontMetrics fm = cadre.getGraphics()
							.getFontMetrics(Logo.police);
					int longueur = fm.stringWidth(liste) + 100;
					Lis lis = new Lis(liste, longueur);
					while (lis.isVisible()) {
						try {
							Thread.sleep(50);
						} catch (InterruptedException e) {
						}
					}
					param = new Stack();
					param.push("\"" + mot);
					String phrase=lis.texte.getText();
					//phrase="[ "+Logo.rajoute_backslash(phrase)+" ] ";
					StringBuffer tampon=new StringBuffer();
					
					for(int j=0;j<phrase.length();j++){
						char c=phrase.charAt(j);
						if (c=='\\') tampon.append("\\\\");
						else tampon.append(c);
					}
					tampon.insert(0,"[ ");
					tampon.append(" ] ");
					phrase=new String(tampon);
					param.push( phrase);
					donne(param);
					String texte = liste + "\n" + phrase;
					cadre.panneauHistorique1.ecris("commentaire", SortieTexte(texte) + "\n");
					cadre.commande.requestFocus();
					lis.dispose();
					cadre.commande.requestFocus();
				} catch (monException e) {
				}
				break;
			case 94: //touche?
				Interprete.operande = true;
				if (cadre.touche.car != -1)
					Interprete.calcul.push(Logo.messages.getString("vrai"));
				else
					Interprete.calcul.push(Logo.messages.getString("faux"));
				break;
			case 95: //siwhile --> Evalue l'expression test du while
				try {
					liste = liste(param.get(1).toString());
					boolean predicat = predicat(param.get(0).toString());
					cadre.primitive.whilesi(predicat, liste);
				} catch (monException e) {
				}
				break;
			case 96: //liscar
				while (cadre.touche.car == -1) {
					try {
						Thread.sleep(100);
					} catch (InterruptedException e) {
					}
					if (monException.lance)
						break;
				}
				Interprete.calcul.push(String.valueOf(cadre.touche.car));
				Interprete.operande = true;
				cadre.touche.car = -1;
				break;
			case 97: //remplis
				cadre.primitive.remplis();
				break;
			case 98: // point
				if (cadre.tortue.visible)
					cadre.primitive.montrecacheTortue();
				try {
					cadre.primitive.point(liste(param.get(0).toString()));
				} catch (monException e) {
				}
				if (cadre.tortue.visible)
					cadre.primitive.montrecacheTortue();
				break;
			case 99: //vers
				try {
					double angle = cadre.primitive.distance(liste(param.get(0)
							.toString()), "vers");
					Interprete.calcul.push(teste_fin_double(angle));
				} catch (monException e) {
				}
				break;
			case 100: //distance
				try {
					double distance = cadre.primitive.distance(liste(param.get(
							0).toString()), "distance");
					Interprete.calcul.push(teste_fin_double(distance));
				} catch (monException e) {
				}
				break;
			case 101: //couleurcrayon
				Interprete.operande = true;
				Interprete.calcul.push("[ "
						+ cadre.tortue.couleurcrayon.getRed() + " "
						+ cadre.tortue.couleurcrayon.getGreen() + " "
						+ cadre.tortue.couleurcrayon.getBlue() + " ] ");
				break;
			case 102: //couleurfond
				Interprete.operande = true;
				Interprete.calcul.push("[ " + cadre.couleurfond.getRed() + " "
						+ cadre.couleurfond.getGreen() + " "
						+ cadre.couleurfond.getBlue() + " ] ");
				break;
			case 103: // bc?
				Interprete.operande = true;
				if (cadre.tortue.baissecrayon)
					Interprete.calcul.push(Logo.messages.getString("vrai"));
				else
					Interprete.calcul.push(Logo.messages.getString("faux"));
				break;
			case 104: //visible?
				Interprete.operande = true;
				if (cadre.tortue.visible)
					Interprete.calcul.push(Logo.messages.getString("vrai"));
				else
					Interprete.calcul.push(Logo.messages.getString("faux"));
				break;
			case 105: // prim?
				try{
					Interprete.operande = true;
					mot = mot(param.get(0));
					if (null == mot)
						throw new monException(cadre, param.get(0).toString() + " "
							+ Logo.messages.getString("doit_etre_mot"));
					if (Primitive.primitives.containsKey(mot))
					Interprete.calcul.push(Logo.messages.getString("vrai"));
					else
						Interprete.calcul.push(Logo.messages.getString("faux"));
				}
				catch(monException e){}
				break;
			case 106: //proc?
				Interprete.operande = true;
				boolean test = false;
				mot = mot(param.get(0));
				for (int i = 0; i < cadre.primitive.procedure.size(); i++) {
					if (((Procedure) cadre.primitive.procedure.get(i)).name
							.equals(mot))
						test = true;
				}
				if (test)
					Interprete.calcul.push(Logo.messages.getString("vrai"));
				else
					Interprete.calcul.push(Logo.messages.getString("faux"));
				break;
			case 107: //exec
				try {
					liste = liste(param.get(0).toString().trim());
					Interprete.instruction.insert(0,new String(Cadre.decoupe(liste)));
					Interprete.renvoi_instruction=true;
				} catch (monException e) {
				}
				break;
			case 108: //catalogue
				String str=SortieTexte(Logo.repertoire_defaut);
				File f = new File(str);
				String fichier = "";
				String dossier = "";
				int nbdossier = 0;
				int nbfichier = 0;
				String[] l = f.list();
				for (int i = 0; i < l.length; i++) {
					if ((new File(str + File.separator
							+ l[i])).isDirectory()) {
						nbdossier++;
						if (nbdossier % 5 == 0)
							dossier += l[i] + "\n";
						else
							dossier += l[i] + " ";
					} else {
						nbfichier++;
						if (nbfichier % 5 == 0)
							fichier += l[i] + "\n";
						else
							fichier += l[i] + " ";
					}
				}
				String texte = "";
				if (!dossier.equals(""))
					texte += Logo.messages.getString("repertoires") + ":\n"
							+ dossier + "\n";
				if (!fichier.equals(""))
					texte += Logo.messages.getString("fichiers") + ":\n"
							+ fichier + "\n";
				cadre.panneauHistorique1.ecris("commentaire", texte);
				break;
			case 109: // frepertoire
				try {
					liste = mot(param.get(0));
					if (null == liste)
						throw new monException(cadre, param.get(0).toString() + " "
								+ Logo.messages.getString("doit_etre_mot"));
					String chemin = SortieTexte(liste);
                   			if ((new File(chemin)).isDirectory()&&!chemin.startsWith("..")){
						Logo.repertoire_defaut = Logo.rajoute_backslash(chemin);
					}
					else throw new monException(cadre, liste
								+ " "
								+ Logo.messages
										.getString("erreur_pas_repertoire"));
				} catch (monException e) {
				}
				break;
			case 110: //repertoire
				Interprete.operande = true;
				Interprete.calcul.push("\"" + Logo.repertoire_defaut );
				break;
			case 111: //sauve
				try {
					mot = mot(param.get(0));
					if (null == mot)
						throw new monException(cadre, Logo.messages
								.getString("erreurmot"));
					liste = liste(param.get(1).toString());
					StringTokenizer st = new StringTokenizer(liste);
					Stack pile = new Stack();
					while (st.hasMoreTokens())
						pile.push(st.nextToken());
					sauve(mot, pile);
				} catch (monException e) {
				}
				break;
			case 112: //sauved
				try {
					mot = mot(param.get(0));
					if (null == mot)
						throw new monException(cadre, param.get(0) + " "
								+ Logo.messages.getString("erreurmot"));
					sauve(mot, null);
				} catch (monException e) {
				}
				break;
			case 113: //ramene
				try {
					mot = mot(param.get(0));
					if (null == mot)
						throw new monException(cadre, param.get(0) + " "
								+ Logo.messages.getString("erreurmot"));
					try {
						String txt = "";
						RandomAccessFile fi = new RandomAccessFile(
								SortieTexte(Logo.repertoire_defaut) + File.separator + mot,
								"r");
						fi.seek(0);
						txt += fi.readUTF();
						fi.close();
						cadre.editeur.zonedition.setText(txt);
					} catch (FileNotFoundException e1) {
						throw new monException(cadre, Logo.messages
								.getString("iolecture"));
					} catch (IOException e2) {
						throw new monException(cadre, Logo.messages
								.getString("iolecture"));
					}
					try {
						cadre.editeur.analyseprocedure();
						if (!cadre.jMenuFileNouveau.isEnabled())
							cadre.jMenuFileNouveau.setEnabled(true);
					} catch (Exception e3) {
						System.out.println(e3.toString());
					}
					cadre.editeur.zonedition.setText("");

				} catch (monException e) {
				}

				break;
			case 114: //pi
				Interprete.operande = true;
				Interprete.calcul.push(String.valueOf(Math.PI));
				break;
			case 115: //tangente
				try {
					Interprete.calcul.push(teste_fin_double(Math.tan(Math
							.toRadians(nombre(param.get(0))))));
				} catch (monException e) {
				}
				Interprete.operande = true;
				break;
			case 116: //acos
				try {
					Interprete.calcul.push(teste_fin_double(Math.toDegrees(Math
							.acos(nombre(param.get(0))))));
				} catch (monException e) {
				}
				Interprete.operande = true;
				break;
			case 117: //asin
				try {
					Interprete.calcul.push(teste_fin_double(Math.toDegrees(Math
							.asin(nombre(param.get(0))))));
				} catch (monException e) {
				}
				Interprete.operande = true;

				break;
			case 118: //atan
				try {
					Interprete.calcul.push(teste_fin_double(Math.toDegrees(Math
							.atan(nombre(param.get(0))))));
				} catch (monException e) {
				}
				Interprete.operande = true;

				break;
			case 119: //vrai
				Interprete.operande = true;
				Interprete.calcul.push(Logo.messages.getString("vrai"));
				break;
			case 120: //faux
				Interprete.operande = true;
				Interprete.calcul.push(Logo.messages.getString("faux"));
				break;
			case 121: //forme
				Interprete.operande = true;
				Interprete.calcul.push(String.valueOf(cadre.tortue.forme));
				break;
			case 122: //fixeforme
				try {
					long i = entier(param.get(0));
					if (cadre.tortue.id == 0) {
						Logo.tortue_choisie = (int) i;
					}
					String chemin = "tortue" + i + ".png";
					Preference.change_image_tortue(cadre, chemin);
				} catch (monException e) {
				}
				break;
			case 123: //definis
				try {
					mot = mot(param.get(0));
					if (null == mot)
						throw new monException(cadre, param.get(0).toString()
								+ " " + Logo.messages.getString("erreurmot"));
					if (mot.equals("")) new monException(cadre, Logo.messages.getString("procedure_vide"));
					String liste1 = liste(param.get(1).toString());
					String liste2 = liste(param.get(2).toString());
					StringTokenizer st = new StringTokenizer(liste1);
					String definition = Logo.messages.getString("pour") + " "
							+ mot + " ";
					StringTokenizer st2;
					while (st.hasMoreTokens()) {
						definition += ":" + st.nextToken() + " ";
					}
					definition += "\n" + liste2 + "\n"
							+ Logo.messages.getString("fin");
					cadre.editeur.zonedition.setText(definition);
				} catch (monException e) {
				}
				try {
					cadre.editeur.analyseprocedure();
					cadre.editeur.zonedition.setText("");
				} catch (Exception e2) {
				}

				break;

			case 124: //tortue
				Interprete.operande = true;
				Interprete.calcul.push(String.valueOf(cadre.tortue.id));
				break;
			case 125: //tortues
				Interprete.operande = true;
				String li = "[ ";
				for (int i = 0; i < cadre.tortues.length; i++) {
					if (null != cadre.tortues[i])
						li += String.valueOf(i) + " ";
				}
				li += "]";
				Interprete.calcul.push(li);
				break;
			case 126: //fixetortue
				try {
					int i = Integer.parseInt(param.get(0).toString());
					if (i > -1 && i < Logo.tortues) {
						if (null == cadre.tortues[i]) {
							cadre.tortues[i] = new Tortue(cadre);
							cadre.tortues[i].id = i;
							cadre.tortues[i].visible = false;
						}
						cadre.tortue = cadre.tortues[i];
						cadre.primitive.g.setStroke(cadre.tortue.crayon);
						String police = cadre.primitive.g.getFont().getName();
						cadre.primitive.g
								.setFont(new java.awt.Font(police,
										java.awt.Font.PLAIN,
										(int) cadre.tortue.police));

					} else {
						try {
							throw new monException(cadre, Logo.messages
									.getString("tortue_inaccessible"));
						} catch (monException e) {
						}
					}
				} catch (NumberFormatException e) {
					try {
						entier(param.get(0));
					} catch (monException e1) {
					}
				}
				break;
			case 127: //police
				Interprete.operande = true;
				Interprete.calcul.push(String.valueOf(cadre.tortue.police));
				break;
			case 128: //fixepolice
				try {
					long taille = entier(param.get(0));
					cadre.tortue.police = (int) taille;
					Font police = Logo.police;
					cadre.primitive.g.setFont(police
							.deriveFont((float) cadre.tortue.police));
				} catch (monException e) {
				}

				break;
			case 129: //tuetortue
				try {
					id = Integer.parseInt(param.get(0).toString());
					if (id > -1 && id < Logo.tortues) {
						//On compte le nombre de tortues  l'cran
						int compteur = 0;
						int premier_dispo = -1;
						for (int i = 0; i < Logo.tortues; i++) {
							if (null != cadre.tortues[i]) {
								if (i != id && premier_dispo == -1)
									premier_dispo = i;
								compteur++;
							}
						}
						//On vrifie que ce n'est pas la seule tortue
						// dispopnible:
						if (null != cadre.tortues[id]) {
							if (compteur > 1) {
								int tortue_utilisee = cadre.tortue.id;
								cadre.tortue = cadre.tortues[id];
								cadre.primitive.ct_mt();
								cadre.tortue = cadre.tortues[tortue_utilisee];
								cadre.tortues[id] = null;
								if (cadre.tortues_visibles.search(String
										.valueOf(id)) > 0)
									cadre.tortues_visibles.remove(String
											.valueOf(id));
								if (cadre.tortue.id == id) {
									cadre.tortue = cadre.tortues[premier_dispo];
									cadre.primitive.g
											.setStroke(cadre.tortue.crayon); //on
																			 // adapte
																			 // le
																			 // nouveau
																			 // crayon
									String police = cadre.primitive.g.getFont()
											.getName();
									cadre.primitive.g
											.setFont(new java.awt.Font(police,
													java.awt.Font.PLAIN,
													(int) cadre.tortue.police));

								}
							} else {
								try {
									throw new monException(cadre, Logo.messages
											.getString("seule_tortue_dispo"));
								} catch (monException e) {
								}
							}
						}
					}
				} catch (NumberFormatException e) {
					try {
						entier(param.get(0));
					} catch (monException e1) {
					}
				}
				break;
			case 130: //sequence
				try {
					liste = liste(param.get(0).toString());
					cadre.son.cree_sequence(Cadre.decoupe(liste).toString());
				} catch (monException e) {
				}

				break;
			case 131: //instrument
				Interprete.operande = true;
				Interprete.calcul.push(String
						.valueOf(cadre.son.getInstrument()));
				break;
			case 132: //fixeinstrument
				try {
					int i = (int) entier(param.get(0));
					cadre.son.setInstrument(i);
				} catch (monException e) {
				}

				break;
			case 133: //joue
				cadre.son.joue();
				break;
			case 134: //effacesequence
				cadre.son.efface_sequence();
				break;
			case 135: //indexsequence
				Interprete.operande = true;
				double d = (double) cadre.son.getTicks() / 64;
				Interprete.calcul.push(teste_fin_double(d));

				break;
			case 136: //fixeindexsequence
				try {
					int i = (int) entier(param.get(0));
					cadre.son.setTicks(i * 64);
				} catch (monException e) {
				}
				break;
			case 137://fpt
				try {
					int i = (int) entier(param.get(0));
					cadre.panneauHistorique1.dsd.fixepolice(i);
				} catch (monException e) {
				}
				break;
			case 138: //ptexte
				Interprete.operande = true;
				Interprete.calcul.push(String.valueOf(cadre.panneauHistorique1
						.police()));
				break;
			case 139: //fct,fixecouleurtexte
				try {
					if (estliste(param.get(0).toString())) {
						cadre.panneauHistorique1.dsd.fixecouleur(rgb(param.get(0)));
					} else {
						int coul=(int)entier(param.get(0)) % Cadre.couleurs.length;
						if (coul<0) coul+=Cadre.couleurs.length;
						cadre.panneauHistorique1.dsd.fixecouleur(Cadre.couleurs[coul]);
					}
				} catch (monException e) {
				}
				break;
			case 140: //couleurtexte
				Interprete.operande = true;
				Color c = cadre.panneauHistorique1.getCouleurtexte();
				Interprete.calcul.push("[ " + c.getRed() + " " + c.getGreen()
						+ " " + c.getBlue() + " ] ");
				break;
			case 141: // lissouris
				while (!cadre.ardoise1.get_lissouris()) {
					try {
						Thread.sleep(100);
					} catch (InterruptedException e) {
					}
					if (monException.lance)
						break;
				}
				Interprete.calcul.push(String.valueOf(cadre.ardoise1
						.get_bouton_souris()));
				Interprete.operande = true;
				break;
			case 142: //possouris
				Interprete.calcul.push(cadre.ardoise1.get_possouris());
				Interprete.operande = true;
				break;
			case 143: //msg message
				try {
					liste = liste(param.get(0).toString());
					StringTokenizer st = new StringTokenizer(liste); // On
																	 // dcoupe
																	 // le
																	 // message
																	 // en
																	 // tranche
																	 // de
																	 // longueurs
																	 // acceptables
					java.awt.FontMetrics fm = cadre.getGraphics()
							.getFontMetrics(Logo.police);
					liste = "";
					String tampon = "";
					while (st.hasMoreTokens()) {
						tampon += st.nextToken() + " ";
						if (fm.stringWidth(tampon) > 200) {
							liste += tampon + "\n";
							tampon = "";
						}
					}
					liste += tampon;
					liste=SortieTexte(liste);
					JTextArea jt = new JTextArea(liste);
					jt.setEditable(false);
					jt.setBackground(new Color(255, 255, 177));
					jt.setFont(Logo.police);
					ImageIcon icone = new ImageIcon(Cadre.class
							.getResource("icone.png"));
					JOptionPane.showMessageDialog(cadre, jt, "",
							JOptionPane.INFORMATION_MESSAGE, (Icon) icone);
				} catch (monException e) {
				}
				break;
			case 144: //date
				Interprete.operande = true;
				Calendar cal = Calendar.getInstance(Logo
						.genere_locale(Logo.langage));
				int jour = cal.get(Calendar.DAY_OF_MONTH);
				int mois = cal.get(Calendar.MONTH) + 1;
				int annee = cal.get(Calendar.YEAR);
				Interprete.calcul.push("[ " + jour + " " + mois + " " + annee
						+ " ] ");
				break;
			case 145: //heure
				Interprete.operande = true;
				cal = Calendar.getInstance(Logo.genere_locale(Logo.langage));
				int heure = cal.get(Calendar.HOUR);
				int minute = cal.get(Calendar.MINUTE);
				int seconde = cal.get(Calendar.SECOND);
				Interprete.calcul.push("[ " + heure + " " + minute + " "
						+ seconde + " ] ");
				break;
			case 146: //temps
				Interprete.operande = true;
				long heure_actuelle = Calendar.getInstance().getTimeInMillis();
				Interprete.calcul
						.push(String
								.valueOf((heure_actuelle - Logo.heure_demarrage) / 1000));
				break;
			case 147: //debuttemps
				try {
					long temps = entier(param.get(0));
					Cadre.chrono = Calendar.getInstance().getTimeInMillis()
							+ 1000 * temps;
				} catch (monException e) {
				}
				break;
			case 148: //fintemps?
				Interprete.operande = true;
				if (Calendar.getInstance().getTimeInMillis() > Cadre.chrono)
					Interprete.calcul.push(Logo.messages.getString("vrai"));
				else
					Interprete.calcul.push(Logo.messages.getString("faux"));
				break;
			case 149: // fnp fixenompolice
				try {
					long int_police = entier(param.get(0));
					Cadre.police_etiquette = (int) int_police
							% Panneau_Police.fontes.length;
				} catch (monException e) {
				}
				break;
			case 150: // np nompolice
				Interprete.operande = true;
				Interprete.calcul.push("[ "
						+ Cadre.police_etiquette
						+ " [ "
						+ Panneau_Police.fontes[Cadre.police_etiquette]
								.getFontName() + " ] ] ");
				break;
			case 151: // fnpt fixenompolicetexte
				try {
					int int_police = (int) entier(param.get(0));
					Cadre.police_ecris = int_police
							% Panneau_Police.fontes.length;
					cadre.panneauHistorique1.dsd.fixenompolice(int_police);
				} catch (monException e) {
				}

				break;
			case 152: //npt nompolicetexte
				Interprete.operande = true;
				Interprete.calcul.push("[ "
						+ Cadre.police_ecris
						+ " [ "
						+ Panneau_Police.fontes[Cadre.police_ecris]
								.getFontName() + " ] ] ");
				break;
			case 153: //listeflux
				liste = "[ ";
				for (int i = 0; i < Logo.chemin_flux.size(); i++) {
					liste += "[ " + Logo.description_flux.get(i).toString()
							+ " " + Logo.chemin_flux.get(i).toString() + " ] ";
				}
				liste += "] ";
				Interprete.operande = true;
				Interprete.calcul.push(liste);
				break;
			case 154: //lisligneflux
				try {
					long ident = entier(param.get(0));
					int index = Logo.description_flux.search(String
							.valueOf(ident));
					if (index == -1)
						throw new monException(cadre, Logo.messages
								.getString("flux_non_disponible")
								+ " " + ident);
					else {
						BufferedReader bfr;
						int index_pile = Logo.flux.size() - index;
						if (null == Logo.flux.get(index_pile))
							bfr = new BufferedReader(
									new FileReader(Logo.chemin_flux.get(
											index_pile).toString()));
						else if (Logo.flux.get(index_pile) instanceof BufferedReader)
							bfr = (BufferedReader) (Logo.flux.get(index_pile));
						else
							throw new monException(cadre, Logo.messages
									.getString("flux_lecture"));
						if (Logo.fin_flux.get(index_pile).toString()
								.equals("1")) {
							throw new monException(cadre, Logo.messages
									.getString("fin_flux")
									+ " " + ident);
						} else {
							String ligne = bfr.readLine();
							if (null == ligne) {
								Logo.fin_flux.set(index_pile, "1");
								throw new monException(cadre, Logo.messages
										.getString("fin_flux")
										+ " " + ident);
							}
							Logo.flux.set(index_pile, bfr);
							Interprete.operande = true;
							Interprete.calcul.push("[ " + Logo.rajoute_backslash(ligne.trim()) + " ] ");
						}
					}
				} catch (FileNotFoundException e1) {
					try {
						throw new monException(cadre, Logo.messages
								.getString("iolecture"));
					} catch (monException e5) {
					}
				} catch (IOException e2) {
				} catch (monException e) {
				}
				break;
			case 155: //liscaractereflux
				try {
					long ident = entier(param.get(0));
					int index = Logo.description_flux.search(String
							.valueOf(ident));
					if (index == -1)
						throw new monException(cadre, Logo.messages
								.getString("flux_non_disponible")
								+ " " + ident);
					else {
						BufferedReader bfr;
						int index_pile = Logo.flux.size() - index;
						if (null == Logo.flux.get(index_pile))
							bfr = new BufferedReader(
									new FileReader(Logo.chemin_flux.get(
											index_pile).toString()));
						else if (Logo.flux.get(index_pile) instanceof BufferedReader)
							bfr = (BufferedReader) (Logo.flux.get(index_pile));
						else
							throw new monException(cadre, Logo.messages
									.getString("flux_lecture"));
						if (Logo.fin_flux.get(index_pile).toString()
								.equals("1")) {
							throw new monException(cadre, Logo.messages
									.getString("fin_flux")
									+ " " + ident);
						} else {
							int ligne = bfr.read();
							if (ligne == -1) {
								Logo.fin_flux.set(index_pile, "1");
								throw new monException(cadre, Logo.messages
										.getString("fin_flux")
										+ " " + ident);
							}
							Logo.flux.set(index_pile, bfr);
							Interprete.operande = true;
							String car=String.valueOf(ligne);
							if (car.equals("\\")) car="\\\\";
							Interprete.calcul.push(car);
						}
					}
				} catch (FileNotFoundException e1) {
					try {
						throw new monException(cadre, Logo.messages
								.getString("iolecture"));
					} catch (monException e5) {
					}
				} catch (IOException e2) {
				} catch (monException e) {
				}
				break;
			case 156: //ecrisligneflux
				try {
					long ident = entier(param.get(0));
					int index = Logo.description_flux.search(String
							.valueOf(ident));
					liste = liste(param.get(1).toString());
					if (index == -1)
						throw new monException(cadre, Logo.messages
								.getString("flux_non_disponible")
								+ " " + ident);
					else {
						BufferedWriter bfw;
						int index_pile = Logo.flux.size() - index;
						if (null == Logo.flux.get(index_pile))
							bfw = new BufferedWriter(
									new FileWriter(Logo.chemin_flux.get(
											index_pile).toString()));
						else if (Logo.flux.get(index_pile) instanceof BufferedWriter)
							bfw = (BufferedWriter) (Logo.flux.get(index_pile));
						else
							throw new monException(cadre, Logo.messages
									.getString("flux_ecriture"));
						PrintWriter pw = new PrintWriter(bfw);
						pw.println(SortieTexte(liste));
						Logo.flux.set(index_pile, bfw);
					}
				} catch (FileNotFoundException e1) {
				} catch (IOException e2) {
				} catch (monException e) {
				}
				break;
			case 157: //finficher?
				try {
					long ident = entier(param.get(0));
					int index = Logo.description_flux.search(String
							.valueOf(ident));
					if (index == -1)
						throw new monException(cadre, Logo.messages
								.getString("flux_non_disponible")
								+ " " + ident);
					else {
						BufferedReader bfr;
						int index_pile = Logo.flux.size() - index;
						if (null == Logo.flux.get(index_pile))
							bfr = new BufferedReader(
									new FileReader(Logo.chemin_flux.get(
											index_pile).toString()));
						else if (Logo.flux.get(index_pile) instanceof BufferedReader)
							bfr = (BufferedReader) (Logo.flux.get(index_pile));
						else
							throw new monException(cadre, Logo.messages
									.getString("flux_lecture"));
						if (Logo.fin_flux.get(index_pile).toString()
								.equals("1")) {
							Interprete.operande = true;
							Interprete.calcul.push(Logo.messages
									.getString("vrai"));
						} else {
							bfr.mark(2);
							int ligne = bfr.read();
							if (ligne == -1) {
								Interprete.operande = true;
								Interprete.calcul.push(Logo.messages
										.getString("vrai"));
								Logo.fin_flux.set(index_pile, "1");
							} else {
								Interprete.operande = true;
								Interprete.calcul.push(Logo.messages
										.getString("faux"));
							}
							bfr.reset();
						}
					}
				} catch (FileNotFoundException e1) {
				} catch (IOException e2) {
				} catch (monException e) {
				}
				break;
			case 158: //ouvreflux
				try {
	
					mot = mot(param.get(1));
					if (null == mot)
						throw new monException(cadre, param.get(0) + " "
								+ Logo.messages.getString("erreurmot"));
					liste = SortieTexte(Logo.repertoire_defaut + File.separator + mot);
					String ident = String.valueOf(entier(param.get(0)));
					if (Logo.description_flux.search(ident) == -1)
						Logo.description_flux.push(ident);
					else
						throw new monException(cadre, ident + " "
								+ Logo.messages.getString("flux_existant"));
					Logo.chemin_flux.push(liste);
					Logo.fin_flux.push("0");
					Logo.flux.push(null);
				} catch (monException e) {
				}
				break;
			case 159: //fermeflux
				try {
					long ident = entier(param.get(0));
					int index = Logo.description_flux.search(String
							.valueOf(ident));
					if (index == -1)
						throw new monException(cadre, Logo.messages
								.getString("flux_non_disponible")
								+ " " + ident);
					else {
						int index_pile = Logo.flux.size() - index;
						if (Logo.flux.get(index_pile) instanceof BufferedReader) { //Le
																				   // flux
																				   // est
																				   // un
																				   // BufferedReader
							BufferedReader bfr = (BufferedReader) (Logo.flux
									.get(index_pile));
							bfr.close();
						} else if (Logo.flux.get(index_pile) instanceof BufferedWriter) { //Le
																						  // flux
																						  // est
																						  // un
																						  // BufferedWriter
							BufferedWriter bfw = (BufferedWriter) (Logo.flux
									.get(index_pile));
							bfw.close();
						}
						Logo.flux.remove(index_pile);
						Logo.chemin_flux.remove(index_pile);
						Logo.description_flux.remove(index_pile);
						Logo.fin_flux.remove(index_pile);
					}
				} catch (IOException e2) {
				} catch (monException e) {
				}
				break;
			case 160: // ajouteligneflux
				try {
					long ident = entier(param.get(0));
					int index = Logo.description_flux.search(String
							.valueOf(ident));
					liste = liste(param.get(1).toString());
					if (index == -1)
						throw new monException(cadre, Logo.messages
								.getString("flux_non_disponible")
								+ " " + ident);
					else {
						BufferedWriter bfw;
						int index_pile = Logo.flux.size() - index;
						if (null == Logo.flux.get(index_pile))
							bfw = new BufferedWriter(
									new FileWriter(Logo.chemin_flux.get(
											index_pile).toString(), true));
						else if (Logo.flux.get(index_pile) instanceof BufferedWriter)
							bfw = (BufferedWriter) (Logo.flux.get(index_pile));
						else
							throw new monException(cadre, Logo.messages
									.getString("flux_ecriture"));
						PrintWriter pw = new PrintWriter(bfw);
						pw.println(SortieTexte(liste));
						Logo.flux.set(index_pile, bfw);
					}
				} catch (FileNotFoundException e1) {
				} catch (IOException e2) {
				} catch (monException e) {
				}

				break;
			case 161: // souris?
				Interprete.operande = true;
				if (cadre.ardoise1.get_lissouris())
					Interprete.calcul.push(Logo.messages.getString("vrai"));
				else
					Interprete.calcul.push(Logo.messages.getString("faux"));
				break;
			case 162: // listevariables
				Interprete.operande = true;
				liste = "[ ";
				for (int i = 0; i < Interprete.locale.size(); i++) {
					liste += Interprete.locale.get(i) + " ";
				}
				for (int i = 0; i < Cadre.globale.size(); i++) {
					Object element = Cadre.globale.get(i);
					if (Interprete.locale.search(element) == -1)
						liste += element.toString() + " ";
				}
				liste += "] ";
				Interprete.calcul.push(liste);
				break;
			case 163: // chose
				mot = mot(param.get(0));
				try {
					if (null == mot) {
						throw new monException(cadre, Logo.messages
								.getString("erreurmot"));
					} // si c'est une liste
					else if (debut_chaine.equals("")) {
						throw new monException(cadre, Logo.messages
								.getString("erreur_variable"));
					} // si c'est un nombre
					Interprete.operande = true;
					Object value;
					mot = mot.toLowerCase();
					int ident = Interprete.locale.search(mot);
					if (ident == -1) {
						ident = Cadre.globale.search(mot);
						if (ident == -1)
							throw new monException(cadre, mot
									+ " "
									+ Logo.messages
											.getString("erreur_variable"));
						else
							value = Cadre.valeur.get(Cadre.globale.size()
									- ident);
					} else {
						value = Interprete.valeur.get(Interprete.locale.size()
								- ident);
					}
					if (null == value)
						throw new monException(cadre, mot + "  "
								+ Logo.messages.getString("erreur_variable"));
					Interprete.calcul.push(value);
				} catch (monException e) {
				}
				break;
			case 164: //nettoie
				cadre.primitive.nettoie();
				break;
			case 165: //tape
				par = param.get(0).toString().trim();
				if (estliste(par))
					par = EcrireListe(par.substring(1, par.length() - 1));
				mot = mot(param.get(0));
				if (null == mot)
					cadre.panneauHistorique1.ecris("perso", SortieTexte(par));
				else
					cadre.panneauHistorique1.ecris("perso", SortieTexte(mot));
				break;
			case 166: //cercle
				try {
					cadre.primitive.arc(nombre(param.pop()),0,360);
				} catch (monException e) {
				}
				break;
			case 167: //arc
				try{
				cadre.primitive.arc(nombre(param.get(0)),nombre(param.get(1)),nombre(param.get(2)));
				}
				catch(monException e){}
			break;
			case 168: //rempliszone
				cadre.primitive.rempliszone();
				break;
			case 169: //animation
				try{
					boolean predic=predicat(param.get(0).toString());
					if (predic) {
						Cadre.mode_classique=false;
						cadre.panneauHistorique1.active_animation();
					}
					else {
						Cadre.mode_classique=true;
						cadre.panneauHistorique1.stop_animation();
					}
					Interprete.operande=false;
				}
				catch(monException e){}
			break;
			case 170: //rafraichis
				cadre.primitive.rafraichis_animation();
			break;
			
			case 171: //tailleimage
				Interprete.operande=true;
				Interprete.calcul.push("[ "+Logo.largeur_dessin+" "+Logo.hauteur_dessin+" ] ");
			break;
			case 172: //quotient
/*				try {
					Interprete.operande=true;
					BigDecimal aa = nombre_precis(param.get(0));
					BigDecimal bb = nombre_precis(param.get(1));
					if (bb.equals(BigDecimal.ZERO)) throw new monException(cadre, Logo.messages
								.getString("division_par_zero"));
					Interprete.calcul.push(aa.divideToIntegralValue(bb));
				} catch (monException e) {
				}*/
				try{
					Interprete.operande=true;
					double aa = nombre(param.get(0));
					double bb = nombre(param.get(1));
					Interprete.calcul.push(String.valueOf((int)(aa/bb)));
				}
				catch(monException e){}
				
				
				break;
			case 173: //entier?
				Interprete.operande=true;
				try {
					double ent = nombre(param.get(0));
					if ((int)ent==ent) Interprete.calcul.push(Logo.messages.getString("vrai"));
					else Interprete.calcul.push(Logo.messages.getString("faux"));
					} 
				catch (monException e) {}		
			break;
			case 174: //fixeseparation
				try {
					double nombre = nombre(param.get(0));
					if (nombre < 0||nombre>1) throw new monException(cadre,nombre+" "+Logo.messages.getString("entre_zero_un"));
					cadre.jSplitPane1.setResizeWeight(nombre);
					cadre.jSplitPane1.setDividerLocation(nombre);
				} catch (monException e) {}
			break;
			case 175: //separation
				Interprete.operande=true;
				Interprete.calcul.push(teste_fin_double(cadre.jSplitPane1.getResizeWeight()));
			break;
			case 176: //tronque
				Interprete.operande=true;
				try {
					BigDecimal ent = nombre_precis(param.get(0));
					Interprete.calcul.push(ent.toBigInteger());
					} 
				catch (monException e) {}
			break;
			case 177: //trace
				try{
					boolean predic=predicat(param.get(0).toString());
					Cadre.mode_trace=predic;
					Interprete.operande=false;
				}
				catch(monException e){}
			break;
			case 178://changedossier
				Interprete.operande=false;
				try {
					mot = mot(param.get(0));
					if (null == mot)
						throw new monException(cadre, param.get(0).toString() + " "
								+ Logo.messages.getString("doit_etre_mot"));
					String chemin="";
					if (Logo.repertoire_defaut.endsWith(File.separator)) chemin=SortieTexte(Logo.repertoire_defaut+mot);
					else chemin = SortieTexte(Logo.repertoire_defaut+Logo.rajoute_backslash(File.separator)+mot); 
 					if ((new File(chemin)).isDirectory()){
						try{
							Logo.repertoire_defaut=Logo.rajoute_backslash((new File(chemin)).getCanonicalPath());		
						}
						catch(NullPointerException e1){}
						catch(IOException e2){}
					}
					else
						throw new monException(cadre, Logo.rajoute_backslash(chemin)
								+ " "
								+ Logo.messages
										.getString("erreur_pas_repertoire"));
				} catch (monException e) {
				}
				
			break;
			case 179://unicode 
				try{
					mot=mot(param.get(0));
					if (null == mot)
						throw new monException(cadre, param.get(0).toString() + " "
								+ Logo.messages.getString("doit_etre_mot"));
					else if (compte_mot(mot)!=1) throw new monException(cadre, param.get(0).toString() + " "
							+ Logo.messages.getString("un_caractere"));
					else {
						Interprete.operande=true;
						String st=String.valueOf((int)SortieTexte(item_mot(1,mot)).charAt(0));
						Interprete.calcul.push(st);
					}
				}
				catch(monException e){}
			break;
			case 180://caractere 
				try{
					long i=entier(param.get(0));
					if (i<0||i>65535) throw new monException(cadre,param.get(0)+" "+Logo.messages.getString("nombre_unicode"));
					else {
						String st="";
						Interprete.operande=true;
						if (i==92) st="\"\\\\";
						else if (i==10) st="\"\\n";
						else if (i==32) st="\"\\e";
						else {
						 st=String.valueOf((char)i);
						 try{
						 	Double.parseDouble(st);
						 }
						 catch(NumberFormatException e){
						 	st="\""+st;
						 }
						}
						Interprete.calcul.push(st);
					}
				}
				catch(monException e){}
			break;
			case 181: //stoptout
				cadre.error=true;
			break;
			case 182: //compteur
				boolean erreur=false;
				if (!Primitive.pile_iteration.isEmpty()){
					bp=(BoucleParametre)Primitive.pile_iteration.peek();
					if (bp.getId().equals("repete")){
						Interprete.operande=true;
						Interprete.calcul.push(bp.getCompteur().toString());
					}
					else erreur=true;
				}
				else erreur=true;
				if (erreur){
					try{
					throw new monException(cadre,Logo.messages.getString("erreur_compteur"));
					}
					catch(monException e){}
				}
			break;
			case 183: //repetepour
				try{
					String li2 = liste(param.get(1).toString());
					li2=new String(Cadre.decoupe(li2));
					String li1 = liste(param.get(0).toString());
					int nb=NombreElement(li1);
					if (nb<3||nb>4) throw new monException(cadre,Logo.messages.getString("erreur_repetepour"));
					StringTokenizer st=new StringTokenizer(li1);
					String var=st.nextToken().toLowerCase();
					BigDecimal deb=nombre_precis(st.nextToken());
					BigDecimal fin=nombre_precis(st.nextToken());
					BigDecimal increment=un;
					if (nb==4) increment=nombre_precis(st.nextToken());
					if (var.equals("")) throw new monException(cadre,Logo.messages.getString("variable_vide"));
					try{Double.parseDouble(var);
						throw new monException(cadre,Logo.messages.getString("erreur_nom_nombre_variable"));
					}
					catch(NumberFormatException e){
						bp=new BoucleParametre(deb,fin,increment,li2,"repetepour",var);
						bp.AffecteVar(true);

						if ((increment.compareTo(zero)==1&&fin.compareTo(deb)>=0)||(increment.compareTo(zero)==-1&&fin.compareTo(deb)<=0)){
							Interprete.instruction.insert(0, li2 + "\\ ");
							Primitive.pile_iteration.push(bp);
						}
					}
				}
				catch(monException e){}			
			break;	
			case 184: //absolue
				try {
					BigDecimal e=nombre_precis(param.get(0));
					Interprete.calcul.push(e.abs().toString());
					Interprete.operande = true;
				} catch (monException e) {
			}
			break;
			case 185: //remplace
				try{
					String reponse="";
					liste=liste(param.get(0).toString());
					int entier=(int)entier(param.get(1));
					mot=mot(param.get(2));
					if (null!=mot&& mot.equals("")) mot="\\v";
					if (null==mot) mot="[ "+liste(param.get(2).toString())+"]";
					char element;
					int compteur = 1;
					boolean espace=false;
					boolean crochet=false;
					boolean error=true;
					for (int j=0;j<liste.length();j++){
						if (compteur==entier) {error=false;compteur=j;break;}
						element=liste.charAt(j);
						if (element=='['){
							if (espace) crochet=true;
							espace=false;
						}
						if (element==' ') {
							espace=true;
							if (crochet) {
								crochet=false;
								j=ExtraitListe(liste,j);
							}
							compteur++;
						}
					}
					if (error)
						throw new monException(cadre, Logo.messages.getString("y_a_pas")
								+ " " + entier + " "
								+ Logo.messages.getString("element_dans_liste") + liste
								+ "]");
					reponse="[ "+liste.substring(0,compteur)+mot;
					// On extrait le mot suivant
					if (compteur<liste.length()&&liste.charAt(compteur)=='['&&liste.charAt(compteur+1)==' '){
							compteur=ExtraitListe(liste,compteur+2);
							reponse+=liste.substring(compteur)+"] ";
						}
					
					else {
						for (int i=compteur+1;i<liste.length();i++){
							if (liste.charAt(i)==' ') {compteur=i;break;}
						}
						reponse+=liste.substring(compteur)+"] ";
					}				
					Interprete.operande=true;
					Interprete.calcul.push(reponse);
				}
				catch(monException e){}
			break;
			case 186: //ajoute
				try{
					String reponse="";
					liste=liste(param.get(0).toString());
					int entier=(int)entier(param.get(1));
					mot=mot(param.get(2));
					if (null!=mot&& mot.equals("")) mot="\\v";
					if (null==mot) mot="[ "+liste(param.get(2).toString())+"]";
					char element;
					int compteur = 1;
					boolean espace=false;
					boolean crochet=false;
					boolean error=true;
					for (int j=0;j<liste.length();j++){
						if (compteur==entier) {error=false;compteur=j;break;}
						element=liste.charAt(j);
						if (element=='['){
							if (espace) crochet=true;
							espace=false;
						}
						if (element==' ') {
							espace=true;
							if (crochet) {
								crochet=false;
								j=ExtraitListe(liste,j);
							}
							compteur++;
							if (j==liste.length()-1&&compteur==entier) {error=false;compteur=liste.length();}
						}
					}
					if (error && entier!=compteur)
						throw new monException(cadre, Logo.messages.getString("y_a_pas")
								+ " " + entier + " "
								+ Logo.messages.getString("element_dans_liste") + liste
								+ "]");
					if (!liste.trim().equals("")) reponse="[ "+liste.substring(0,compteur)+mot+" "+liste.substring(compteur)+"] ";
					else reponse="[ "+mot+" ] ";
					Interprete.operande=true;
					Interprete.calcul.push(reponse);
				}
				catch(monException e){}
			break;
			case 187: // gris
				codecouleur(8);
			break;	
			case 188: // grisclair
				codecouleur(9);
			break;	
			case 189: // rougefonce
				codecouleur(10);
			break;	
			case 190: // vertfonce
				codecouleur(11);
			break;	
			case 191: // bleufonce
				codecouleur(12);
			break;	
			case 192: // orange
				codecouleur(13);
			break;	
			case 193: // rose
				codecouleur(14);
			break;	
			case 194: // violet
				codecouleur(15);
			break;	
			case 195: // marron
				codecouleur(16);
			break;
			case 196: // noir
				codecouleur(0);
			break;	
			case 197: // rouge
				codecouleur(1);
			break;	
			case 198: // vert
				codecouleur(2);
			break;	
			case 199: // jaune
				codecouleur(3);
			break;	
			case 200: // bleu
				codecouleur(4);
			break;	
			case 201: // magenta
				codecouleur(5);
			break;	
			case 202: // cyan
				codecouleur(6);
			break;	
			case 203: // blanc
				codecouleur(7);
			break;	
			case 204: // Parenthse fermante
				// Distinguons les deux cas : (3)*2 et (4+3)*2
				// Le 3 est ici  retourner au +
				boolean a_retourner = true; 
				//On enleve le "(" correspondant  la parenthese ouvrante de la pile nom
				// a condition que l'lment attendant de la pile nom ne soit pas une procdure
				boolean est_procedure=false;
				int pos=Interprete.nom.lastIndexOf("(");
				if (pos==-1){
					// Parenthese fermante sans parenthese ouvrante au pralable
					try{throw new monException(cadre,Logo.messages.getString("parenthese_ouvrante"));}
					catch(monException e){}
				} 
				else { // Evitons l'erreur en cas de par exemple ec ) (parenthese fermante sans ouvrante)--> else  excuter qu'en cas de non erreur
				if (Interprete.drapeau_ouvrante) {
					// parenthese vide
					try{throw new monException(cadre,Logo.messages.getString("parenthese_vide"));}
					catch(monException e){}
	
				}
				for(int j=pos;j<Interprete.nom.size();j++){
					String proc=Interprete.nom.get(j).toString();
					if (Primitive.primitives.containsKey(proc)) est_procedure=true;
					else {	
						for (int i=0;i<cadre.primitive.procedure.size();i++){
							if (((Procedure)cadre.primitive.procedure.get(i)).name.equals(proc)) 
								{est_procedure=true;break;}
							}
							if (est_procedure) break;
						}
					}
				}
				// Si une procdure est prsente dans la pile nom, on garde les parenthses
//				System.out.println(Primitive.primitives.containsKey("puissance")+" "+est_procedure);
				if (est_procedure) {
					Interprete.instruction.insert(0,") ");
				}
				// Sinon on les enleve avec leurs imbrications ventuelles
					else {
						if (Interprete.en_cours.isEmpty()||!Interprete.en_cours.peek().toString().equals("("))
						{try{throw new monException(cadre,Logo.messages.getString("parenthese_ouvrante"));}
						catch(monException e){}}
					else Interprete.en_cours.pop();
						if (!Interprete.nom.isEmpty()) {
							if (Interprete.nom.peek().toString().equals("(")) a_retourner=false;
							pos=Interprete.nom.lastIndexOf("(");
							if (pos==-1){
								// Parenthese fermante sans parenthese ouvrante au pralable
								try{throw new monException(cadre,Logo.messages.getString("parenthese_ouvrante"));}
								catch(monException e){}
							} 
							else {
								Interprete.nom.removeElementAt(pos);
								// S'il y a imbrication de parenthses (((20)))
								pos--;
								while (Interprete.mot().equals(")")&&(pos>-1)){
									if (!Interprete.nom.isEmpty()&&Interprete.nom.get(pos).toString().equals("(")){
										Interprete.enleve(")");
										Interprete.nom.removeElementAt(pos);
										pos--;
									}
									else break;
								}
							}           	
						}
					}
				if (Interprete.calcul.isEmpty()){
                	Interprete.operande=false;
                }
                else {
                	Interprete.operande = true;
                    Interprete.drapeau_fermante=a_retourner;
                }
                break;
                case 205: //fixestyle
                	try{
                   		boolean gras=false;
                		boolean italique=false;
						boolean souligne=false;
						boolean exposant=false;
						boolean indice=false;
						boolean barre=false;
						mot = mot(param.get(0));
						if (null == mot) liste = liste(param.get(0).toString());
                		else liste=mot;
						if (liste.trim().equals("")) liste=Logo.messages.getString("aucun");
                		StringTokenizer st=new StringTokenizer(liste);
                		while (st.hasMoreTokens()){
                			String element=st.nextToken().toLowerCase();
                			if (element.equals(Logo.messages.getString("souligne").toLowerCase())){
                				souligne=true;
                			}
                			else if (element.equals(Logo.messages.getString("gras").toLowerCase())){
                				gras=true;
                			}
                			else if (element.equals(Logo.messages.getString("italique").toLowerCase())){
                				italique=true;
                			}
                			else if (element.equals(Logo.messages.getString("exposant").toLowerCase())){
                				exposant=true;
                			}
                			else if (element.equals(Logo.messages.getString("indice").toLowerCase())){
                				indice=true;
                			}
                			else if (element.equals(Logo.messages.getString("barre").toLowerCase())){
                				barre=true;
                			}
                			else if (element.equals(Logo.messages.getString("aucun").toLowerCase())) {}
                			else throw new monException(cadre,Logo.messages.getString("erreur_fixestyle"));
                		}
                		cadre.panneauHistorique1.dsd.fixegras(gras);
                		cadre.panneauHistorique1.dsd.fixeitalique(italique);
                		cadre.panneauHistorique1.dsd.fixesouligne(souligne);
                		cadre.panneauHistorique1.dsd.fixeexposant(exposant);
                		cadre.panneauHistorique1.dsd.fixeindice(indice);
                		cadre.panneauHistorique1.dsd.fixebarre(barre);
                	}
                	catch(monException e){}
                break;
                case 206: //style
                	StringBuffer buffer=new StringBuffer();
                	int compteur=0;
                	if (cadre.panneauHistorique1.dsd.estgras()) {buffer.append(Logo.messages.getString("gras").toLowerCase()+" "); compteur++;}
                	if (cadre.panneauHistorique1.dsd.estitalique()) {buffer.append(Logo.messages.getString("italique").toLowerCase()+" "); compteur++;}
                	if (cadre.panneauHistorique1.dsd.estsouligne()) {buffer.append(Logo.messages.getString("souligne").toLowerCase()+" "); compteur++;}
                	if (cadre.panneauHistorique1.dsd.estexposant()) {buffer.append(Logo.messages.getString("exposant").toLowerCase()+" "); compteur++;}
                	if (cadre.panneauHistorique1.dsd.estindice()) {buffer.append(Logo.messages.getString("indice").toLowerCase()+" "); compteur++;}
                	if (cadre.panneauHistorique1.dsd.estbarre()) {buffer.append(Logo.messages.getString("barre").toLowerCase()+" "); compteur++;}
                	Interprete.operande=true;
                	if (compteur==0) Interprete.calcul.push("\""+Logo.messages.getString("aucun").toLowerCase());
                	else if (compteur==1) Interprete.calcul.push("\""+new String(buffer).trim());
                	else if (compteur>1)  Interprete.calcul.push("[ "+new String(buffer)+"]");
                break;
			}
			
		}
	}
	private void codecouleur(int i){
		Interprete.operande=true;
		Color co=Cadre.couleurs[i];
		Interprete.calcul.push("[ "+co.getRed()+" "+co.getGreen()+" "+co.getBlue()+" ]");
	}
	private void sauve(String fichier, Stack pile) throws monException {
		try {
			String aecrire = "";
			boolean bool = true;
			if (!fichier.endsWith(".lgo"))
				fichier += ".lgo";
			RandomAccessFile f = new RandomAccessFile(SortieTexte(Logo.repertoire_defaut)
					+ File.separator + fichier, "rw");
			try {
				for (int i = 0; i < cadre.primitive.procedure.size(); i++) {
					Procedure procedure = ((Procedure) cadre.primitive.procedure
							.get(i));
					if (null == pile)
						bool = true;
					else
						bool = (pile.search(procedure.name) != -1);
					if (procedure.affichable && bool) {
						aecrire += Logo.messages.getString("pour") + " "
								+ procedure.name;
						for (int j = 0; j < procedure.nbparametre; j++) {
							aecrire += " :"
									+ procedure.variable.get(j).toString();
						}
						aecrire += "\n" + procedure.instruction
								+ Logo.messages.getString("fin") + "\n\n";
					}
				}
			} catch (NullPointerException ex) {
			} //Si aucune procdure n'a t dfinie.
			f.writeUTF(aecrire);
			f.close();
		} catch (FileNotFoundException e1) {
			throw new monException(cadre, Logo.messages.getString("ioecriture"));
		} catch (IOException e2) {
			cadre.panneauHistorique1.ecris("erreur", Logo.messages
					.getString("ioecriture"));
		}
	}

	private BufferedImage testechemin(String chemin) throws monException {
		BufferedImage image = null;
		chemin = mot(chemin);
		if (!(chemin.endsWith(".png") || chemin.endsWith(".jpg")))
			throw new monException(cadre, Logo.messages
					.getString("erreur_format_image"));
		else {
			try {
				chemin = SortieTexte(chemin);
				File f = new File(SortieTexte(Logo.repertoire_defaut)+File.separator+chemin);
				image = ImageIO.read(f);
			} catch (Exception e1) {
				throw new monException(cadre, Logo.messages
						.getString("iolecture"));
			}
		}
		return image;
	}

	void locale(Stack param) throws monException {
		String mot = mot(param.get(0));
		if (null != mot) {
			mot=mot.toLowerCase();
			Interprete.locale.push(mot);
			Interprete.valeur.push(null);
		} else
			throw new monException(cadre, param.get(0).toString()
					+ Logo.messages.getString("erreurmot"));
	}

	Color trouvecouleur(Object ob) throws monException {
		int[] pixel = new int[10];
		String liste = "";
		try {
			liste = liste(ob.toString());
		} catch (monException e) {
		}
		StringTokenizer st = new StringTokenizer(liste);
		int x = 1;
		int y = 1;
		try {
			if (!st.hasMoreTokens())
				throw new monException(cadre, Logo.messages.getString("tc")
						+ " " + Logo.messages.getString("n_aime_pas") + liste
						+ Logo.messages.getString("comme_parametre"));
			String li = st.nextToken().toString();
			if (li.equals("-")) {
				if (st.hasMoreTokens())
					li = st.nextToken().toString();
				x = -1;
			}
			x = (int) (x * Double.parseDouble(li) + Logo.largeur_dessin/2);
			if (!st.hasMoreTokens())
				throw new monException(cadre, Logo.messages.getString("tc")
						+ " " + Logo.messages.getString("n_aime_pas") + liste
						+ Logo.messages.getString("comme_parametre"));
			li = st.nextToken().toString();
			if (li.equals("-")) {
				if (st.hasMoreTokens())
					li = st.nextToken().toString();
				y = -1;
			}
			y = (int) (Logo.hauteur_dessin/2 - Double.parseDouble(li) * y);
		} catch (NumberFormatException e) {
			throw new monException(cadre, Logo.messages.getString("tc") + " "
					+ Logo.messages.getString("n_aime_pas") + " " + liste
					+ Logo.messages.getString("comme_parametre"));
		}
		int couleur = -1;
		if (st.hasMoreTokens())
			throw new monException(cadre, Logo.messages.getString("tc") + " "
					+ Logo.messages.getString("n_aime_pas") + liste
					+ Logo.messages.getString("comme_parametre"));
		if (0 < x && x < Logo.largeur_dessin && 0 < y && y < Logo.hauteur_dessin) {
			couleur = cadre.ardoise1.dessin.getRGB(x, y);
		}
		return new Color(couleur);
	}

	Color rgb(Object obj) throws monException {
		String liste = liste(obj.toString());
		StringTokenizer st = new StringTokenizer(liste);
		if (st.countTokens() != 3)
			throw new monException(cadre, Logo.messages.getString("fcc_fcfg"));
		int[] entier = new int[3];
		for (int i = 0; i < 3; i++) {
			String element=st.nextToken();
			try{
				entier[i] = (int)(Double.parseDouble(element)+0.5)% 256;
			}
			catch(NumberFormatException e){
				throw new monException(cadre,element+" "+Logo.messages.getString("pas_nombre"));
			}
			if (entier[i]<0) entier[i]+=256;
		}
		return (new Color(entier[0], entier[1], entier[2]));
	}

	void fcfg(Stack param) throws monException {
		Color couleur = null;
		if (estliste(param.get(0).toString())) {
			try {
				couleur = rgb(param.get(0));
			} catch (monException e) {
			}
		} else {
			int coul=(int)entier(param.get(0)) % Cadre.couleurs.length;
			if (coul<0) coul+=Cadre.couleurs.length;
			couleur = Cadre.couleurs[coul];
		}
		Graphics g = cadre.ardoise1.dessin.getGraphics();
		g.setColor(couleur);
		g.fillRect(0, 0, Logo.largeur_dessin,Logo.hauteur_dessin);
		cadre.couleurfond = couleur;
		cadre.primitive.videecran();
		cadre.ardoise1.repaint();
	}

	void fcc(Stack param) throws monException {
		if (estliste(param.get(0).toString())) {
			try {
				cadre.tortue.couleurcrayon = rgb(param.get(0));
			} catch (monException e) {
			}
		} else {
			int coul=(int)entier(param.get(0)) % Cadre.couleurs.length;
			if (coul<0) coul+=Cadre.couleurs.length;
			cadre.tortue.couleurcrayon = Cadre.couleurs[coul];
		}
	}

	void membre(Stack param, int id) throws monException {
		Interprete.operande = true;
		String mot_retourne = null;
		boolean b = false;
		String mot = mot(param.get(1));
		String liste = "[ ";
		if (null == mot) { //on travaille sur une liste
			try {
				liste = liste(param.get(1).toString());
				StringTokenizer st = new StringTokenizer(liste);
				liste = "[ ";
				mot = mot(param.get(0));
				String str;
				if (null!=mot&& mot.equals("")) mot="\\v";
				if (null == mot)
					mot = param.get(0).toString().trim();
				while (st.hasMoreTokens()) {
					str = st.nextToken();
					if (str.equals("["))
						str = ExtraitListe(st);
					if (!liste.equals("[ "))
						liste += str + " ";
					if (str.equals(mot) && liste.equals("[ ")) {
						if (id == 69) {
							b = true;
							break;
						} else
							liste += str + " ";
					}
				}
			} catch (monException ex) {
			}
		} else { //on travaille sur un mot
			String mot2 = mot(param.get(0));
			if (null != mot2) {
				boolean backslash=false;
				for (int i = 0; i < mot.length(); i++) {
					char c=mot.charAt(i);
					if (!backslash&&c=='\\') backslash=true;  
					else  {
						String tmp=Character.toString(c);
							if (backslash) tmp="\\"+tmp;  
						if (tmp.equals(mot2)){
							if (id == 69) {
								b = true;
								break;
							} else {
								if (!backslash)	mot_retourne = mot.substring(i, mot.length());
								else mot_retourne=mot.substring(i-1, mot.length());
								break;
							}	
						}
						backslash=false;
					}
				}
			}
		}
		if (!liste.equals("[ "))
			Interprete.calcul.push(liste + "] ");
		else if (null != mot_retourne){
			try{
				Double.parseDouble(mot_retourne);
				Interprete.calcul.push(mot_retourne);
			}
			catch(NumberFormatException e){
				Interprete.calcul.push(debut_chaine+mot_retourne);
			}
		}
		else if (b)
			Interprete.calcul.push(Logo.messages.getString("vrai"));
		else
			Interprete.calcul.push(Logo.messages.getString("faux"));
	}

	void precede(Stack param) throws monException {
		Interprete.operande = true;
		boolean b = false;
		String ope[] = { "", "" };
		String mot = "";
		for (int i = 0; i < 2; i++) {
			mot = mot(param.get(i));
			if (null == mot)
				throw new monException(cadre, param.get(i).toString() + " "
						+ Logo.messages.getString("pas_mot"));
			else
				ope[i] = mot;
		}
		if (ope[1].compareTo(ope[0]) > 0)
			b = true;
		if (b)
			mot = Logo.messages.getString("vrai");
		else
			mot = Logo.messages.getString("faux");
		Interprete.calcul.push(mot);
	}

	void egal(Stack param) {
		try {
			double ope1, ope2 = 0;
			ope1 = Double.parseDouble(param.get(0).toString());
			ope2 = Double.parseDouble(param.get(1).toString());
			if (ope2 == ope1)
				Interprete.calcul.push(Logo.messages.getString("vrai"));
			else
				Interprete.calcul.push(Logo.messages.getString("faux"));
		} catch (NumberFormatException e) {
			if (param.get(0).toString().equals(param.get(1).toString()))
				Interprete.calcul.push(Logo.messages.getString("vrai"));
			else
				Interprete.calcul.push(Logo.messages.getString("faux"));
		}
		Interprete.operande = true;
	}

	boolean predicat(String st) throws monException {
		if (st.toLowerCase().equals(Logo.messages.getString("vrai")))
			return true;
		else if (st.toLowerCase().equals(Logo.messages.getString("faux")))
			return false;
		else
			throw new monException(cadre, st + " "
					+ Logo.messages.getString("pas_predicat"));

	}

	double nombre(Object st) throws monException { //Si un nombre est un double
		try {
			return (Double.parseDouble(st.toString()));
		} catch (NumberFormatException e) {
			throw new monException(cadre, st.toString() + " "
					+ Logo.messages.getString("pas_nombre"));
		}
	}

	BigDecimal nombre_precis(Object st) throws monException { //Si un nombre
															  // est un double
		try {
			return (new BigDecimal(st.toString()));
		} catch (NumberFormatException e) {
			throw new monException(cadre, st.toString() + " "
					+ Logo.messages.getString("pas_nombre"));
		}
	}

	String mot(Object st) { // Si c'est un mot
		String liste = st.toString();
		if (liste.equals("\"")) {
			debut_chaine = "";
			return "";
		}
		if (liste.length() > 0 && liste.substring(0, 1).equals("\"")) {
			debut_chaine = "\"";
			return (liste.substring(1, liste.length()));
		} else
			try {
				Double.parseDouble(liste);
				debut_chaine = "";
				return liste;
			} catch (NumberFormatException e) {
			}
		return (null);
	}

	long entier(Object st) throws monException { //Si c'est un entier
		try {
			double ent = Double.parseDouble(st.toString());
			if (ent == 0)
				return 0;
			long enti = Math.round(ent);
			if (ent / enti == 1)
				return ((long) enti);
			else
				Integer.parseInt("a");
		} catch (NumberFormatException e) {
			throw new monException(cadre, st.toString() + " "
					+ Logo.messages.getString("pas_entier"));
		}
		return (0);
	}

	String liste(String li) throws monException {
		li = li.trim();
		//Retourne la liste sans crochets;
		if (li.substring(0, 1).equals("[")
				&& li.substring(li.length() - 1, li.length()).equals("]")) {
			li = li.substring(1, li.length() - 1).trim() + " ";
			if (!li.equals(" "))
				return li;
			else
				return ("");
		} else
			throw new monException(cadre, li + " "
					+ Logo.messages.getString("pas_liste"));
	}

	boolean estliste(String li) {
		li = li.trim();
		if (li.length() > 0 && li.substring(0, 1).equals("[")
				&& li.substring(li.length() - 1, li.length()).equals("]"))
			return (true);
		return false;
	}

	String EcrireListe(String li) {
		String tampon = "";
		String precedent = "";
		StringTokenizer st = new StringTokenizer(li, " []", true);
		String element = "";
		while (st.hasMoreTokens()) {
			element = st.nextToken();
			while (st.hasMoreTokens() && element.equals(" ")) {
				element = st.nextToken();
			}
			if (element.equals("]"))
				tampon = tampon.trim() + "] ";
			else if (element.equals("[")) {
				if (precedent.equals("["))
					tampon += "[";
				else
					tampon = tampon.trim() + " [";
			}
			else
				tampon += element + " ";
			precedent = element;
		}
		return (tampon.trim());
	}

	String ExtraitListe(StringTokenizer st) {
		int compteur = 1;
		String crochet = "[ ";
		String element = "";
		while (st.hasMoreTokens()) {
			element = st.nextToken();
			if (element.equals("[")) {
				compteur++;
				crochet += "[ ";
			} else if (!element.equals("]"))
				crochet += element + " ";
			else if (compteur != 1) {
				compteur--;
				crochet += "] ";
			} else {
				crochet += element + " ";
				break;
			}
		}
		element = crochet;
		compteur = 0;
		return element.trim();
	}

	int ExtraitListe(String st, int deb) {
		int compteur = 1;
		String crochet = "[ ";
		char element;
		boolean espace=false;
		boolean crochet_ouvert=false;;
		boolean crochet_ferme=false;
		for (int i=deb;i<st.length();i++) {
			element = st.charAt(i);
			if (element=='[') {
				if (espace) crochet_ouvert=true;
				espace=false;
				crochet_ferme=false;
			}
			else if (element==']') {
				if (espace) crochet_ferme=true;
				espace=false;
				crochet_ouvert=false;
			} 
			else if (element==' '){
				espace=true;
				if (crochet_ouvert) {
					compteur++;
					crochet_ouvert=false;
				}
				else if (crochet_ferme){
					crochet_ferme=false;
					if (compteur!=1) compteur--;
					else {compteur=i;break;}
				}
			}
		}
		return compteur;
	}

	
	
	
	int NombreElement(String liste) { //calcule le nombre d'lments dans une
									  // liste
		StringTokenizer st = new StringTokenizer(liste);
		int i = 0;
		String element = "";
		while (st.hasMoreTokens()) {
			element = st.nextToken();
			if (element.equals("["))
				element = ExtraitListe(st);
			i++;
		}
		return i;
	}

	String item(String liste, long i) throws monException { // retourne
															// l'lment i d'une
															// liste
		StringTokenizer st = new StringTokenizer(liste);
		String element = "";
		int j = 0;
		while (st.hasMoreTokens()) {
			j++;
			element = st.nextToken();
			if (element.equals("["))
				element = ExtraitListe(st);
			if (j == i)
				break;
		}
		if (j != i)
			throw new monException(cadre, Logo.messages.getString("y_a_pas")
					+ " " + i + " "
					+ Logo.messages.getString("element_dans_liste") + liste
					+ "]");
		else if (i == 0 && j == 0)
			throw new monException(cadre, Logo.messages.getString("liste_vide"));
		try {
			double d=Double.parseDouble(element);
			return element;
		} // Si c'est un nombre, on le renvoie.
		catch (Exception e) {
		}
		if (element.startsWith("["))
			return element; //C'est une liste, on la renvoie telle quelle.
		if (element.equals("\\v")) element="";
		return "\"" + element; //C'est forcment un mot, on le renvoie.
	}

	void donne(Stack param) throws monException {
		String mot = mot(param.get(0));
		if (null == mot)
			throw new monException(cadre, param.get(0).toString() + " "
					+ Logo.messages.getString("doit_etre_mot"));
		mot = mot.toLowerCase();
		if (mot.equals("")) throw new monException(cadre,Logo.messages.getString("variable_vide"));
		try{Double.parseDouble(mot);
			throw new monException(cadre,Logo.messages.getString("erreur_nom_nombre_variable"));
		}
		catch(NumberFormatException e){
			int id = Interprete.locale.search(mot);
			if (id != -1) {
				Interprete.valeur.set(Interprete.valeur.size() - id, param.get(1));
			} else {
				id = Cadre.globale.search(mot);
				if (id != -1) {
					Cadre.valeur.set(Cadre.valeur.size() - id, param.get(1));
				} else {
					Cadre.globale.push(mot);
					Cadre.valeur.push(param.get(1));
				}	
			}
		}
	}

	private void delay() {
		if (Logo.vitesse != 0) {
			try {
				Thread.sleep(Logo.vitesse * 5);
			} catch (InterruptedException e) {
			}
		}
	}

	private String teste_fin_double(double d) {
		String st = String.valueOf(d);
		if (st.endsWith(".0"))
			st = st.substring(0, st.length() - 2);
		return st;
	}
	static String SortieTexte(String chaine){ // Enlve les backslash
		StringBuffer buffer=new StringBuffer();
		boolean backslash=false;
		for (int j=0;j<chaine.length();j++){
			char c=chaine.charAt(j);
			if (backslash) {
				if (c=='e') buffer.append(' ');
//				else if (c=='\\') buffer.append('\\');
				else if (c=='n') buffer.append("\n");
				else if(c=='v') buffer.append("");
				else if("[]()#\\".indexOf(c)>-1) buffer.append(c);
				backslash=false;
			}
			else {
				if (c=='\\') backslash=true;
				else buffer.append(c);
			}
		}
		return new String(buffer);
	}
	 int compte_mot(String mot){//retourne le nombre de caractres d'un mot
	 	int compteur=0;
	 	boolean backslash=false;
	 	for(int i=0;i<mot.length();i++){
	 		if (!backslash&&mot.charAt(i)=='\\') backslash=true;
	 		else {backslash=false;compteur++;}
	 	}
	 	return compteur;
	 }
	 String item_mot(int entier,String mot) throws monException{
	 	String reponse="";
	 	int compteur=1;
	 	boolean backslash=false;
	 	if (mot.equals("")) throw new monException(cadre,Logo.messages.getString("mot_vide"));
	 	for(int i=0;i<mot.length();i++){
	 		char c=mot.charAt(i);
	 		if (!backslash&&c=='\\') backslash=true;
	 		else {
	 			if (compteur==entier){
	 				if (backslash) reponse="\\"+Character.toString(c);
	 				else reponse=Character.toString(c);
	 				break;
	 			}
	 			else {compteur++;backslash=false;}
	 		} 		
	 	}
	 return reponse;	
	 }
}