
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.image.BufferedImage;
import java.util.Locale;
import java.util.ResourceBundle;
import java.util.Stack;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.awt.RenderingHints;
import java.math.BigDecimal;
import java.awt.Rectangle;
public class Primitive {
	Cadre cadre;

	//  float taille_crayon=(float)0;
	Stack points = new Stack();

	Graphics graph;

	Graphics2D g;

	Stack procedure = new Stack();

	BasicStroke crayon_triangle = new BasicStroke(1);

	final String[] primitive = { "av", "re", "td", "tg", "puissance", "repete",
			"ve", "ct", "mt", "ec", "si", "stop", "origine", "fpos", "fixex",
			"fixey", "fixexy", "fixecap", "lc", "bc", "go", "ic", "de",
			"somme", "difference", "moins", "produit", "div", "reste",
			"ret", "*", "/", "+", "-", "=", "<", ">", "|", "&", "\n", "\\",
			"pos", "cap", "arrondi", "log10", "sin", "cos", "ou", "et", "non",
			"liste", "ph", "mp", "md", "inverse", "choix", "enleve", "item",
			"sd", "sp", "dernier", "premier", "compte", "mot?", "nombre?",
			"liste?", "vide?", "egal?", "precede?", "membre?", "racine",
			"membre", "donne", "locale", "donnelocale", "fcc", "fcfg",
			"hasard", "attends", "imts", "efn", "efv", "efns", "mot",
			"etiquette", "tc", "fen", "enr", "clos", "vt", "ci", "ftc",
			"tantque", "lis", "touche?", "siwhile", "liscar", "remplis",
			"point", "vers", "distance", "cc", "cf", "bc?", "visible?",
			"prim?", "proc?", "exec", "cat", "frep", "rep", "sauve", "sauved",
			"ramene", "pi", "tan", "acos", "asin", "atan", "vrai", "faux",
			"forme", "fforme", "def", "tortue", "tortues", "ftortue", "police",
			"fpolice", "tuetortue", "seq", "instr", "finstr", "joue", "efseq",
			"indseq", "findseq", "fpt", "ptexte", "fct", "couleurtexte",
			"lissouris", "possouris", "message", "date", "heure", "temps",
			"debuttemps", "fintemps?", "fixenompolice", "nompolice",
			"fixenompolicetexte", "nompolicetexte", "listeflux",
			"lisligneflux", "liscarflux", "ecrisligneflux", "finflux?",
			"ouvreflux", "fermeflux", "ajouteligneflux", "souris?",
			"listevariables", "chose", "nettoie", "tape", "cercle", "arc",
			"rempliszone","animation","rafraichis","tailleimage","quotient","entier?",
			"fixeseparation","separation","tronque","trace","changedossier","unicode","caractere",
			"stoptout","compteur","repetepour","absolue","remplace","ajoute","gris","grisclair",
			"rougefonce","vertfonce","bleufonce","orange","rose","violet","marron","noir","rouge",
			"vert","jaune","bleu","magenta","cyan","blanc",")","fixestyle","style"
			};

	final int[] parametres = { 1, 1, 1, 1, 2, 2, 0, 0, 0, 1, 2, 0, 0, 1, 1, 1,
			2, 1, 0, 0, 0, 0, 0, 2, 2, 1, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1,
			1, 0, 0, 0, 0, 1, 1, 1, 1, 2, 2, 1, 2, 2, 2, 2, 1, 1, 2, 2, 1, 1,
			1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 1, 2, 2, 1, 2, 1, 1, 1, 1, 0, 1, 1,
			0, 2, 1, 1, 0, 0, 0, 0, 1, 1, 2, 2, 0, 2, 0, 0, 1, 1, 1, 0, 0, 0,
			0, 1, 1, 1, 0, 1, 0, 2, 1, 1, 0, 1, 1, 1, 1, 0, 0, 0, 1, 3, 0, 0,
			1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1,
			0, 1, 0, 1, 0, 0, 1, 1, 2, 1, 2, 1, 2, 0, 0, 1, 0, 1, 1, 3, 0 ,1,0,
			0,2,1,1,0,1,1,1,1,1,0,0,2,1,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
			1,0};

	static TreeMap primitives = new TreeMap(); // Treemap contenant les noms des

	// primitives (recherche efficace)

	int nouvx, nouvy, oldx, oldy;

	int nbproc = 0; //nb de procdures dfinies par l'utilisateur (hors

	// fichiers de dmarrage)


	static Stack pile_iteration = new Stack();
	public Primitive() {
	}

	public Primitive(Cadre cadre) {
		//construire le Treemap des primitives
		construis_treemap(Logo.langage);
		//initialiser les variables
		this.cadre = cadre;
		g = (Graphics2D) cadre.ardoise1.dessin.getGraphics();
		graph = cadre.ardoise1.getGraphics();
	}

	//Excution des primitives
	void construis_treemap(int id) {
		primitives = new TreeMap();
		Locale locale = Logo.genere_locale(Logo.langage);
		ResourceBundle prim = ResourceBundle.getBundle("primitives", locale);
		//    System.out.println(primitive.length);
		for (int i = 0; i < primitive.length; i++) {
			String cle = primitive[i];
			if (i==39) primitives.put("\n", "39");
		//	else if (i==204) primitives.put("\\p", "204");
			else {
				if (cle.length() != 1) {
					cle = prim.getString(cle);
				}
				StringTokenizer st = new StringTokenizer(cle);
				int compteur = 0;
				while (st.hasMoreTokens()) {
					primitives.put(st.nextToken(), String.valueOf(i + 210
							* compteur));
					compteur++;
				}
			}
		}
	}

	void av(double arg) {
		oldx = (int) (cadre.tortue.corX + 0.5); //On arrondit au pixel le plus
		// proche
		oldy = (int) (cadre.tortue.corY + 0.5); //idem
		if (Cadre.etat_fenetre == 0) { //mode fenetre
			//if (cadre.tortue.visible) montrecacheTortue();
			montrecacheTortue();
			cadre.tortue.corX = cadre.tortue.corX + arg
					* Math.cos(cadre.tortue.angle);
			cadre.tortue.corY = cadre.tortue.corY - arg
					* Math.sin(cadre.tortue.angle);
			//      System.out.println("position "+cadre.tortue.corX+"
			// "+cadre.tortue.corY);
			if (cadre.tortue.baissecrayon) {
				nouvx = (int) (cadre.tortue.corX + 0.5); //idem
				nouvy = (int) (cadre.tortue.corY + 0.5); //idem
				if (cadre.tortue.inversecrayon) {
					g.setColor(cadre.couleurfond);
					g.setXORMode(cadre.tortue.couleurcrayon);
				} else {
					g.setColor(cadre.tortue.couleurcrayon);
					g.setPaintMode();
				}
//			System.out.println(oldx+" "+oldy+" "+nouvx+" "+nouvy);
				if (oldx < nouvx)
					g.drawLine(oldx, oldy, nouvx, nouvy);
				else
					g.drawLine(nouvx, nouvy, oldx, oldy);
				clip(Math.min(oldx, nouvx)
						- (int) (cadre.tortue.taille_crayon * 1.4), Math.min(
						oldy, nouvy)
						- (int) (cadre.tortue.taille_crayon * 1.4), Math
						.abs(oldx - nouvx)
						+ 1 + (int) (cadre.tortue.taille_crayon * 3), Math
						.abs(oldy - nouvy)
						+ 1 + (int) (cadre.tortue.taille_crayon * 3));
			}
			//       if (cadre.tortue.visible) montrecacheTortue();
			montrecacheTortue();
		} else if (Cadre.etat_fenetre == 1) { //mode enroule
			trace_enroule(arg, oldx, oldy);
		} else if (Cadre.etat_fenetre == 2) { //mode clos
			try {
				trace_ferme(oldx, oldy, arg);
			} catch (monException e) {
			}
		}
	}

	void arc(double rayon, double pangle, double fangle) {
		montrecacheTortue();
		//On dfinit les coordonnes du coin suprieur gauche
		int x = (int) (cadre.tortue.corX - rayon + 0.5); //On arrondit au pixel
														 // le plus proche
		int y = (int) (cadre.tortue.corY - rayon + 0.5); //idem
		int hauteur = (int) (2 * rayon + 0.5);
		if (cadre.tortue.inversecrayon) {
			g.setColor(cadre.couleurfond);
			g.setXORMode(cadre.tortue.couleurcrayon);
		} else {
			g.setColor(cadre.tortue.couleurcrayon);
			g.setPaintMode();
		}
		// Cas du cercle
		if (pangle == 0 && fangle == 360) {
			g.drawOval(x, y, hauteur, hauteur);
			int tcrayon= (int)cadre.tortue.taille_crayon+1;
			clip(x - tcrayon, y - tcrayon, hauteur + 2*tcrayon, hauteur + 2*tcrayon);

		} else {
			// Est-ce que les angles sont bien clairs?
			fangle = (90 - fangle) % 360;
			pangle = (90 - pangle) % 360;
			if (pangle < 0)
				pangle += 360;

			// angle  valeurs entires
			if (fangle == (int) fangle && pangle == (int) pangle) {
				if (fangle < 0)
					fangle += 360;
				double angle = (pangle - fangle) % 360;
				if (angle < 0)
					angle += 360;
				g.drawArc(x, y, hauteur, hauteur, (int) (fangle + 0.5),
						(int) (0.5 + angle));
				int tcrayon= (int)cadre.tortue.taille_crayon;
				clip(x - tcrayon, y  - tcrayon, hauteur + 2* tcrayon, hauteur + 2* tcrayon);
			}
			// Angles dcimaux
			else {
				double angle = (pangle - fangle) % 360;
				//	
				g.translate(cadre.tortue.corX, cadre.tortue.corY);
				g.rotate(Math.toRadians(-fangle));
				g.drawArc((int) (-rayon - 0.5), (int) (-rayon - 0.5), hauteur,
						hauteur, 0, (int) (angle));
				double angle_rotation = angle - 1;
				int argument = 1;
				if (angle < 0) {
					angle_rotation = angle + 1;
					argument = -1;
				}
				g.rotate(Math.toRadians(-angle_rotation));
				g.drawArc((int) (-rayon - 0.5), (int) (-rayon - 0.5), hauteur,
						hauteur, 0, argument);

				g.rotate(Math.toRadians(angle_rotation));
				g.rotate(Math.toRadians(fangle));
				g.translate(-cadre.tortue.corX, -cadre.tortue.corY);
				int tcrayon= (int)cadre.tortue.taille_crayon+1;
				clip(x - tcrayon, y - tcrayon, hauteur + 2*tcrayon, hauteur + 2*tcrayon);
			}
		}
		montrecacheTortue(); // on efface la tortue si elle st visible

	}

	void chargeimage(BufferedImage image) {
		if (cadre.tortue.visible)
			montrecacheTortue();
		g.setPaintMode();
		g.setClip((int) cadre.tortue.corX, (int) cadre.tortue.corY, image
				.getWidth(), image.getHeight());
		g.drawImage(image, null, (int) cadre.tortue.corX,
				(int) cadre.tortue.corY);
		g.setClip(0, 0, Logo.largeur_dessin,Logo.hauteur_dessin);
		graph.setPaintMode();
		clip((int) cadre.tortue.corX, (int) cadre.tortue.corY, image
				.getWidth(), image.getHeight());
		if (Cadre.mode_classique) graph.setClip(0, 0, Logo.largeur_dessin,Logo.hauteur_dessin);
		if (cadre.tortue.visible)
			montrecacheTortue();
	}

	double trouve_longueur(double mini, double maxi, double oldx, double oldy) {
		// renvoie la longueur dont on peut encore avancer
		if (Math.abs(maxi - mini) < 0.5){
			return (mini);}
		else {
			double milieu = (mini + maxi) / 2;
			double nx = oldx + milieu * Math.cos(cadre.tortue.angle);
			double ny = oldy - milieu * Math.sin(cadre.tortue.angle);
			if (nx < 0 || nx > Logo.largeur_dessin|| ny < 0 || ny > Logo.hauteur_dessin)
				return trouve_longueur(mini, milieu, oldx, oldy);
			else
				return trouve_longueur(milieu, maxi, oldx, oldy);
		}
	}

	void trace_enroule(double arg, double oldx, double oldy) {
		boolean re = false;
		if (arg < 0) {
			re = true;
		}
		double diagonale=Math.sqrt(Math.pow(Logo.largeur_dessin,2)+Math.pow(Logo.hauteur_dessin,2))+1;
		double longueur;
		if (re)
			longueur = trouve_longueur(0, -diagonale, oldx, oldy);
		else
			longueur = trouve_longueur(0, diagonale, oldx, oldy);
//		System.out.println(diagonale+" "+oldx+" "+oldy);
		while (Math.abs(longueur) < Math.abs(arg)) {
		//	System.out.println(Math.abs(longueur)+" "+Math.abs(arg));
			arg -= longueur;
			Cadre.etat_fenetre = 0;
			av(longueur);
			//System.out.println(Math.abs(longueur)+" "+Math.abs(arg));
			if (cadre.error)
				break; //permet d'interrompre avec le bouton stop
			Cadre.etat_fenetre = 1;
			if (Logo.vitesse != 0) {
				try {
					Thread.sleep(Logo.vitesse * 5);
				} catch (InterruptedException e) {
				}
			}
			if (cadre.tortue.visible)
				this.montrecacheTortue();
				if (re) cadre.tortue.cap=(cadre.tortue.cap+180)%360;
			if (cadre.tortue.corX > Logo.largeur_dessin-1
					&& (cadre.tortue.cap < 180 && cadre.tortue.cap != 0)) {
				cadre.tortue.corX = 0;
				if (cadre.tortue.corY > Logo.hauteur_dessin-1
						&& (cadre.tortue.cap > 90 && cadre.tortue.cap < 270))
					cadre.tortue.corY = 0;
				else if (cadre.tortue.corY < 1
						&& (cadre.tortue.cap < 90 || cadre.tortue.cap > 270))
					cadre.tortue.corY = Logo.hauteur_dessin;
			} else if (cadre.tortue.corX < 1 && cadre.tortue.cap > 180) {
				cadre.tortue.corX = Logo.largeur_dessin;
				if (cadre.tortue.corY > Logo.hauteur_dessin-1
						&& (cadre.tortue.cap > 90 && cadre.tortue.cap < 270))
					cadre.tortue.corY = 0;
				else if (cadre.tortue.corY < 1
						&& (cadre.tortue.cap < 90 || cadre.tortue.cap > 270))
					cadre.tortue.corY = Logo.hauteur_dessin;
			} else if (cadre.tortue.corY > Logo.hauteur_dessin-1)
				cadre.tortue.corY = 0;
			else if (cadre.tortue.corY < 1)
				cadre.tortue.corY = Logo.hauteur_dessin;
			if (re) cadre.tortue.cap=(cadre.tortue.cap+180)%360;
			if (cadre.tortue.visible)
				this.montrecacheTortue();
			if (re)
				longueur = trouve_longueur(0, -diagonale, cadre.tortue.corX,
						cadre.tortue.corY);
			else
				longueur = trouve_longueur(0, diagonale, cadre.tortue.corX,
						cadre.tortue.corY);
		}
		Cadre.etat_fenetre = 0;
		if (!cadre.error)
			av(arg);
		Cadre.etat_fenetre = 1;
	}

	void trace_ferme(int oldx, int oldy, double arg) throws monException {
		boolean re = false;
		double longueur;
		double diagonale=Math.sqrt(Math.pow(Logo.largeur_dessin,2)+Math.pow(Logo.hauteur_dessin,2))+1;
		if (arg < 0)
			re = true;
		if (re)
			longueur = trouve_longueur(0, -diagonale, oldx, oldy);
		else
			longueur = trouve_longueur(0, diagonale, oldx, oldy);
		if (Math.abs(longueur) < Math.abs(arg))
			throw new monException(cadre, Logo.messages
					.getString("erreur_sortie1")
					+ "\n"
					+ Logo.messages.getString("erreur_sortie2")
					+ Math.abs((int) (longueur)));
		else {
			Cadre.etat_fenetre = 0;
			av(arg);
			Cadre.etat_fenetre = 2;
		}
	}

	void point(String liste) throws monException {
		double y = 1.0;
		double x = 1.0;
		StringTokenizer st = new StringTokenizer(liste);
		try {
			if (!st.hasMoreTokens())
				throw new monException(cadre, Logo.messages.getString("point")
						+ " " + Logo.messages.getString("n_aime_pas") + liste
						+ Logo.messages.getString("comme_parametre"));
			String li = st.nextToken().toString();
			if (li.equals("-")) {
				if (st.hasMoreTokens())
					li = st.nextToken().toString();
				x = -1;
			}
			x = x * Double.parseDouble(li) + Logo.largeur_dessin/2;
			if (!st.hasMoreTokens())
				throw new monException(cadre, Logo.messages.getString("point")
						+ " " + Logo.messages.getString("n_aime_pas") + liste
						+ Logo.messages.getString("comme_parametre"));
			li = st.nextToken().toString();
			if (li.equals("-")) {
				if (st.hasMoreTokens())
					li = st.nextToken().toString();
				y = -1;
			}
			y = Logo.hauteur_dessin/2 - Double.parseDouble(li) * y;
		} catch (NumberFormatException e) {
			throw new monException(cadre, Logo.messages.getString("point")
					+ " " + Logo.messages.getString("n_aime_pas") + liste
					+ Logo.messages.getString("comme_parametre"));
		}
		if (st.hasMoreTokens())
			throw new monException(cadre, Logo.messages.getString("point")
					+ " " + Logo.messages.getString("n_aime_pas") + liste
					+ Logo.messages.getString("comme_parametre"));
		if (x>0 && y>0 && x<Logo.hauteur_dessin && y < Logo.largeur_dessin) {
			if (cadre.tortue.taille_crayon == 0)
				cadre.ardoise1.dessin.setRGB((int) x, (int) y,
						cadre.tortue.couleurcrayon.getRGB());
			else {
				g.setColor(cadre.tortue.couleurcrayon);
				g.fillRect((int) (x - cadre.tortue.taille_crayon / 2),
						(int) (y - cadre.tortue.taille_crayon / 2),
						(int) cadre.tortue.taille_crayon,
						(int) cadre.tortue.taille_crayon);
			}
			clip((int) (x - cadre.tortue.taille_crayon / 2),
				(int) (y - cadre.tortue.taille_crayon / 2),
				(int) (x + cadre.tortue.taille_crayon / 2),
				(int) (y + cadre.tortue.taille_crayon / 2));
		}
	}

	void fpos(String liste) throws monException {
		double y = 1.0;
		double x = 1.0;
		StringTokenizer st = new StringTokenizer(liste);
		try {
			if (!st.hasMoreTokens())
				throw new monException(cadre, Logo.messages.getString("fpos")
						+ " " + Logo.messages.getString("n_aime_pas") + liste
						+ Logo.messages.getString("comme_parametre"));
			String li = st.nextToken().toString();
			if (li.equals("-")) {
				if (st.hasMoreTokens())
					li = st.nextToken().toString();
				x = -1;
			}
			x = x * Double.parseDouble(li) + Logo.largeur_dessin/2;
			if (!st.hasMoreTokens())
				throw new monException(cadre, Logo.messages.getString("fpos")
						+ " " + Logo.messages.getString("n_aime_pas") + liste
						+ Logo.messages.getString("comme_parametre"));
			li = st.nextToken().toString();
			if (li.equals("-")) {
				if (st.hasMoreTokens())
					li = st.nextToken().toString();
				y = -1;
			}
			y = Logo.hauteur_dessin/2 - Double.parseDouble(li) * y;
		} catch (NumberFormatException e) {
			throw new monException(cadre, Logo.messages.getString("fpos") + " "
					+ Logo.messages.getString("n_aime_pas") + liste
					+ Logo.messages.getString("comme_parametre"));
		}
		if (st.hasMoreTokens())
			throw new monException(cadre, Logo.messages.getString("fpos") + " "
					+ Logo.messages.getString("n_aime_pas") + liste
					+ Logo.messages.getString("comme_parametre"));

		oldx = (int) (cadre.tortue.corX + 0.5); //On arrondit au pixel le plus
		// proche
		oldy = (int) (cadre.tortue.corY + 0.5); //idem

		//      if (cadre.tortue.visible) montrecacheTortue();
		montrecacheTortue();
		cadre.tortue.corX = x;
		cadre.tortue.corY = y;
		if (cadre.tortue.baissecrayon) {
			nouvx = (int) (cadre.tortue.corX + 0.5); //idem
			nouvy = (int) (cadre.tortue.corY + 0.5); //idem
			if (cadre.tortue.inversecrayon) {
				g.setColor(cadre.couleurfond);
				g.setXORMode(cadre.tortue.couleurcrayon);
			} else {
				g.setColor(cadre.tortue.couleurcrayon);
				g.setPaintMode();
			}
			g.drawLine(oldx, oldy, nouvx, nouvy);
			clip(Math.min(oldx, nouvx)
					- (int) (cadre.tortue.taille_crayon * 1.4), Math.min(oldy,
					nouvy)
					- (int) (cadre.tortue.taille_crayon * 1.4), Math.abs(oldx
					- nouvx)
					+ 1 + (int) (cadre.tortue.taille_crayon * 3), Math.abs(oldy
					- nouvy)
					+ 1 + (int) (cadre.tortue.taille_crayon * 3));
		}
		//      if (cadre.tortue.visible) montrecacheTortue();
		montrecacheTortue();
	}

	double distance(String liste, String nom) throws monException {
		double y = 1.0;
		double x = 1.0;
		StringTokenizer st = new StringTokenizer(liste);
		try {
			if (!st.hasMoreTokens())
				throw new monException(cadre, nom + " "
						+ Logo.messages.getString("n_aime_pas") + liste
						+ Logo.messages.getString("comme_parametre"));
			String li = st.nextToken().toString();
			if (li.equals("-")) {
				if (st.hasMoreTokens())
					li = st.nextToken().toString();
				x = -1;
			}
			x = x * Double.parseDouble(li) + Logo.largeur_dessin/2;
			if (!st.hasMoreTokens())
				throw new monException(cadre, nom + " "
						+ Logo.messages.getString("n_aime_pas") + liste
						+ Logo.messages.getString("comme_parametre"));
			li = st.nextToken().toString();
			if (li.equals("-")) {
				if (st.hasMoreTokens())
					li = st.nextToken().toString();
				y = -1;
			}
			y = Logo.hauteur_dessin/2 - Double.parseDouble(li) * y;
		} catch (NumberFormatException e) {
			throw new monException(cadre, nom + " "
					+ Logo.messages.getString("n_aime_pas") + liste
					+ Logo.messages.getString("comme_parametre"));
		}
		if (st.hasMoreTokens())
			throw new monException(cadre, nom + " "
					+ Logo.messages.getString("n_aime_pas") + liste
					+ Logo.messages.getString("comme_parametre"));
		Interprete.operande = true;
		if (nom.equals("distance")) {
			double distance = Math.sqrt(Math.pow(cadre.tortue.corX - x, 2)
					+ Math.pow(cadre.tortue.corY - y, 2));
			return distance;
		} else {
			double angle;
			if (cadre.tortue.corY == y) {
				if (x > cadre.tortue.corX)
					angle = 90;
				else if (x == cadre.tortue.corX)
					angle = 0;
				else
					angle = 270;
			} else if (cadre.tortue.corX == x) {
				if (cadre.tortue.corY > y)
					angle = 0;
				else
					angle = 180;
			} else {
				angle = Math.toDegrees(Math.atan(Math
						.abs(x - cadre.tortue.corX)
						/ Math.abs(cadre.tortue.corY - y)));
				if (x > cadre.tortue.corX && y > cadre.tortue.corY)
					angle = 180 - angle; // 2eme quadrant
				else if (x < cadre.tortue.corX && y > cadre.tortue.corY)
					angle = 180 + angle; // 3eme quadrant
				else if (x < cadre.tortue.corX && y < cadre.tortue.corY)
					angle = 360 - angle; // 4eme quadrant
			}
			return angle;
		}
	}

	void ct_mt() {
		if (null == cadre.tortue.tort) {
			g.setXORMode(Color.black);
			cadre.tortue.coord();
			BasicStroke crayon_actuel = (BasicStroke) g.getStroke();
			if (crayon_actuel.getLineWidth() == 1)
				g.drawPolygon(cadre.tortue.triangle);
			else {
				g.setStroke(crayon_triangle);
				g.drawPolygon(cadre.tortue.triangle);
				g.setStroke(crayon_actuel);
			}
		} else {
			g.setXORMode(cadre.couleurfond);
			double angle = Math.PI / 2 - cadre.tortue.angle;
			float x = (float) (cadre.tortue.corX * Math.cos(angle) + cadre.tortue.corY
					* Math.sin(angle));
			float y = (float) (-cadre.tortue.corX * Math.sin(angle) + cadre.tortue.corY
					* Math.cos(angle));
			g.rotate(angle);
			g.drawImage(cadre.tortue.tort, (int) x - cadre.tortue.largeur / 2,
					(int) y - cadre.tortue.hauteur / 2, cadre.ardoise1);
			g.rotate(-angle);
		}
		clip((int) (cadre.tortue.corX - cadre.tortue.gabarit),
				(int) (cadre.tortue.corY - cadre.tortue.gabarit),
				cadre.tortue.gabarit * 2, cadre.tortue.gabarit * 2);
	}

	void montrecacheTortue() {
		g.setColor(cadre.couleurfond);
		for (int i = 0; i < cadre.tortues_visibles.size(); i++) {
			int id = Integer.parseInt(String.valueOf(cadre.tortues_visibles
					.get(i)));

			if (null == cadre.tortues[id].tort) {
				g.setXORMode(Color.black);
				cadre.tortues[id].coord();
				BasicStroke crayon_actuel = (BasicStroke) g.getStroke();
				if (crayon_actuel.getLineWidth() == 1)
					g.drawPolygon(cadre.tortues[id].triangle);
				else {
					g.setStroke(crayon_triangle);
					g.drawPolygon(cadre.tortues[id].triangle);
					g.setStroke(crayon_actuel);
				}
			} else {
				g.setXORMode(cadre.couleurfond);
				double angle = Math.PI / 2 - cadre.tortues[id].angle;
				float x = (float) (cadre.tortues[id].corX * Math.cos(angle) + cadre.tortues[id].corY
						* Math.sin(angle));
				float y = (float) (-cadre.tortues[id].corX * Math.sin(angle) + cadre.tortues[id].corY
						* Math.cos(angle));
				g.rotate(angle);
				g.drawImage(cadre.tortues[id].tort, (int) x
						- cadre.tortues[id].largeur / 2, (int) y
						- cadre.tortues[id].hauteur / 2, cadre.ardoise1);
				g.rotate(-angle);
			}
			clip(	(int) (cadre.tortues[id].corX - cadre.tortues[id].gabarit),
					(int) (cadre.tortues[id].corY - cadre.tortues[id].gabarit),
					cadre.tortues[id].gabarit * 2,
					cadre.tortues[id].gabarit * 2);
		}
	}

	void td(double arg) {
//		System.out.println(cadre.tortue.angle);
		if (cadre.tortue.visible)
			montrecacheTortue();
		cadre.tortue.cap = ((cadre.tortue.cap + arg) % 360 + 360) % 360;
		cadre.tortue.angle = Math.toRadians(90 - cadre.tortue.cap);
		if (cadre.tortue.visible)
			montrecacheTortue();
		Interprete.operande = false;
	}

	void repete(long i, String st) {
		if (i > 0) {
				st=new String(Cadre.decoupe(st));
				BoucleParametre bp =new BoucleParametre(LancePrimitive.un,new BigDecimal(i),LancePrimitive.un,st,"repete");
				pile_iteration.push(bp);
				Interprete.instruction.insert(0, st + "\\ ");
		}
	}

	void videecran() {
		g.setPaintMode();
		g.setColor(cadre.couleurfond);
		g.fillRect(0, 0, Logo.largeur_dessin,Logo.hauteur_dessin);
		// Rinitialiser les tortues
		if (null == cadre.tortues[0])
			cadre.tortues[0] = new Tortue(cadre);
		cadre.tortue = cadre.tortues[0]; //la tortue active sera  prsent la
		// numro 0
		cadre.tortue.id = 0;
		for (int i = 1; i < cadre.tortues.length; i++) { //On limine les
			// autres tortues
			cadre.tortues[i] = null;
		}
		cadre.tortues_visibles.removeAllElements();
		cadre.tortues_visibles.push("0");
		g.setColor(cadre.tortue.couleurcrayon);
		graph.setClip(0, 0, Logo.largeur_dessin,Logo.hauteur_dessin);
		if (Cadre.mode_classique) {
					graph.drawImage(cadre.ardoise1.dessin, 0, 0, cadre.ardoise1);
		}
		cadre.tortue.init();
		cadre.tortue.visible = true;
		cadre.tortue.couleurcrayon = Color.BLACK;
		g.setStroke(new BasicStroke(1));
		montrecacheTortue();
	}

	void nettoie() {
		g.setPaintMode();
		g.setColor(cadre.couleurfond);
		g.fillRect(0, 0, Logo.largeur_dessin,Logo.hauteur_dessin);
		/* Rinitialiser les tortues
		if (null == cadre.tortues[0])
			cadre.tortues[0] = new Tortue(cadre);
		cadre.tortue = cadre.tortues[0]; //la tortue active sera  prsent la
		// numro 0
		cadre.tortue.id = 0;
		for (int i = 1; i < cadre.tortues.length; i++) { //On limine les
			// autres tortues
			cadre.tortues[i] = null;
		}
		cadre.tortues_visibles.removeAllElements();
		cadre.tortues_visibles.push("0");*/
		g.setColor(cadre.tortue.couleurcrayon);
		graph.setClip(0, 0, Logo.largeur_dessin,Logo.hauteur_dessin);
		if (Cadre.mode_classique) graph.drawImage(cadre.ardoise1.dessin, 0, 0, cadre.ardoise1);
		if (cadre.tortue.visible)
			montrecacheTortue();
		else
			cadre.tortues_visibles = new Stack();
	}

	void si(boolean b, String li, String li2) {
		if (b) {
			Interprete.instruction.insert(0,li);
		} else if (null != li2) {
			Interprete.instruction.insert(0,li2);
		}
	}

	void whilesi(boolean b, String li) {
		if (b) {
			Interprete.instruction.insert(0,li+ ((BoucleParametre)Primitive.pile_iteration.peek()).getInstr());
		} else {
			try {
				Interprete.tueniveau("\\", cadre);
			} catch (monException e) {
			}
		}
	}

	int bornes_remplis_zone(int x, int y, int increment, int couleur_frontiere) {
		while (!meme_couleur(cadre.ardoise1.dessin.getRGB(x, y) ,couleur_frontiere)) {
			cadre.ardoise1.dessin.setRGB(x, y, couleur_frontiere);
			x = x + increment;
			if (!(x > 0 && x < Logo.largeur_dessin-1))
				break;
		}
		return x - increment;
	}
	boolean meme_couleur(int col1,int col2){
		if (Logo.qualite==1){
			int rouge1 = (col1 >> 16) & 0xFF;
			int vert1 = (col1 >> 8) & 0xFF;
			int bleu1 = col1 & 0xFF;
			int rouge2 = (col2 >> 16) & 0xFF;
			int vert2 = (col2 >> 8) & 0xFF;
			int bleu2 = col2 & 0xFF;
			int tolerance=120;
			int diff_rouge=rouge1-rouge2;
			int diff_bleu=bleu1-bleu2;
			int diff_vert=vert1-vert2;
			boolean rouge;boolean vert; boolean bleu;
			if (rouge1>rouge2){
				if (rouge1-rouge2< 128 -rouge2/2) rouge=true;
				else rouge=false;
			}
			else{
				if (rouge2-rouge1<rouge2/2) rouge=true;
				else rouge=false;
			}
			if (vert1>vert2){
				if (vert1-vert2< 128 -vert2/2) vert=true;
				else vert=false;
			}
			else{
				if (vert2-vert1<vert2/2) vert=true;
				else vert=false;
			}
			if (bleu1>bleu2){
				if (bleu1-bleu2< 128 -bleu2/2) bleu=true;
				else bleu=false;
			}
			else{
				if (bleu2-bleu1<bleu2/2) bleu=true;
				else bleu=false;
			}

		return rouge&&bleu&&vert;	
//			if (Math.abs(rouge1-rouge2)<tolerance&&Math.abs(vert1-vert2)<tolerance&&Math.abs(bleu1-bleu2)<tolerance&&Math.abs(rouge1+bleu1+vert1-rouge2-bleu2-vert2)<450)
//			return true;
	//	else return false;
		}
		else{
			return (col1==col2);
		}
	}
	void rempliszone() {
		montrecacheTortue();
		int x = (int) (cadre.tortue.corX + 0.5);
		int y = (int) (cadre.tortue.corY + 0.5);
		if (x > 0 & x < Logo.largeur_dessin & y > 0 & y < Logo.hauteur_dessin) {
			int couleur_origine = cadre.ardoise1.dessin.getRGB(x, y);
			int couleur_frontiere = cadre.tortue.couleurcrayon.getRGB();
		//	System.out.println(couleur_origine+" " +couleur_frontiere);
			Stack pile_germes = new Stack();
			boolean couleurs_differentes = cadre.tortue.baissecrayon
					&& !meme_couleur(couleur_origine,couleur_frontiere);
			if (couleurs_differentes)
				pile_germes.push(new Point(x, y));
			while (!pile_germes.isEmpty()) {

				Point p = (Point) pile_germes.pop();
				int xgerme = p.x;
				int ygerme = p.y;
				int xmax = bornes_remplis_zone(xgerme, ygerme, 1,
						couleur_frontiere);
				int xmin = bornes_remplis_zone(xgerme - 1, ygerme, -1,
						couleur_frontiere);
				boolean ligne_dessus = false;
				boolean ligne_dessous = false;
				for (int i = xmin; i < xmax + 1; i++) {
					//on recherche les germes au dessus et au dessous
					if (ygerme > 0
							&& meme_couleur(cadre.ardoise1.dessin.getRGB(i, ygerme - 1) ,couleur_frontiere)) {
						if (ligne_dessus)
							pile_germes.push(new Point(i - 1, ygerme - 1));
						ligne_dessus = false;
					} else {
						ligne_dessus = true;
						if (i == xmax && ygerme > 0)
							pile_germes.push(new Point(xmax, ygerme - 1));
					}
					if (ygerme < Logo.hauteur_dessin-1
							&& meme_couleur(cadre.ardoise1.dessin.getRGB(i, ygerme + 1),couleur_frontiere)) {
						if (ligne_dessous)
							pile_germes.push(new Point(i - 1, ygerme + 1));
						ligne_dessous = false;
					} else {
						ligne_dessous = true;
						if (i == xmax && ygerme < Logo.hauteur_dessin-1)
							pile_germes.push(new Point(xmax, ygerme + 1));
					}
				}
			}
			if (Cadre.mode_classique){
				graph.setClip(0, 0,Logo.largeur_dessin,Logo.hauteur_dessin);
				graph.drawImage(cadre.ardoise1.dessin, 0, 0, cadre);
			}
			montrecacheTortue();
		}
	}

	int bornes_remplis(int x, int y, int increment, int couleur_crayon,
			int couleur_origine) {
		while (cadre.ardoise1.dessin.getRGB(x, y) == couleur_origine) {
			cadre.ardoise1.dessin.setRGB(x, y, couleur_crayon);
			x = x + increment;
			if (!(x > 0 && x < Logo.largeur_dessin-1))
				break;
		}
		return x - increment;
	}

	void remplis() {
		montrecacheTortue();
		int x = (int) (cadre.tortue.corX + 0.5);
		int y = (int) (cadre.tortue.corY + 0.5);
		if (x > 0 & x < Logo.largeur_dessin & y > 0 & y < Logo.hauteur_dessin) {
		int couleur_origine = cadre.ardoise1.dessin.getRGB(x, y);
		int couleur_crayon = cadre.tortue.couleurcrayon.getRGB();
		if (x > 0 & x < Logo.largeur_dessin & y > 0 & y < Logo.hauteur_dessin) {
			Stack pile_germes = new Stack();
			boolean couleurs_differentes = cadre.tortue.baissecrayon
					&& !(couleur_origine == couleur_crayon);
			if (couleurs_differentes)
				pile_germes.push(new Point(x, y));
			while (!pile_germes.isEmpty()) {
				Point p = (Point) pile_germes.pop();
				int xgerme = p.x;
				int ygerme = p.y;
				//			System.out.println(xgerme+" "+ygerme);
				int xmax = bornes_remplis(xgerme, ygerme, 1, couleur_crayon,
						couleur_origine);
				int xmin = bornes_remplis(xgerme - 1, ygerme, -1,
						couleur_crayon, couleur_origine);
				//				System.out.println("xmax "+xmax+"xmin "+xmin);
				boolean ligne_dessus = false;
				boolean ligne_dessous = false;
				for (int i = xmin; i < xmax + 1; i++) {
					//on recherche les germes au dessus et au dessous
					if (ygerme > 0
							&& cadre.ardoise1.dessin.getRGB(i, ygerme - 1) != couleur_origine) {
						if (ligne_dessus)
							pile_germes.push(new Point(i - 1, ygerme - 1));
						ligne_dessus = false;
					} else {
						ligne_dessus = true;
						if (i == xmax && ygerme > 0)
							pile_germes.push(new Point(xmax, ygerme - 1));
					}
					if (ygerme < Logo.hauteur_dessin-1
							&& cadre.ardoise1.dessin.getRGB(i, ygerme + 1) != couleur_origine) {
						if (ligne_dessous)
							pile_germes.push(new Point(i - 1, ygerme + 1));
						ligne_dessous = false;
					} else {
						ligne_dessous = true;
						if (i == xmax && ygerme < Logo.hauteur_dessin-1)
							pile_germes.push(new Point(xmax, ygerme + 1));
					}
				}
			}
			if (Cadre.mode_classique){
				graph.setClip(0, 0, Logo.largeur_dessin,Logo.hauteur_dessin);
				graph.drawImage(cadre.ardoise1.dessin, 0, 0, cadre);
			}
			montrecacheTortue();
		}
		}
	}

	void stop() {
		Interprete.operande = false;
		try {
			Interprete.tueniveau("\\", cadre);
		} catch (monException e) {
		}
	}

	void retourne(String val) throws monException {
	//	System.out.println("nom: "+Interprete.nom);
//		System.out.println("valeur"+val+" recursivite "+Interprete.recursivite);
		Interprete.calcul.push(val);
		Interprete.operande = true;
		if (Cadre.mode_trace) {
			StringBuffer buffer=new StringBuffer();
			for (int i=0;i<Interprete.en_cours.size()-1;i++) buffer.append("  ");
			buffer.append(Interprete.en_cours.peek());
			buffer.append(" "+Logo.messages.getString("retourne")+" "+val);
			cadre.panneauHistorique1.ecris("normal",LancePrimitive.SortieTexte(buffer.toString())+"\n");
		}
		if ((!Interprete.nom.isEmpty())
				&& Interprete.nom.peek().toString().equals("\n")) {
			try {
				Interprete.tueniveau("\n", cadre);
			} catch (monException e) {
			}
			Interprete.nom.pop();
		} else if (!Interprete.nom.isEmpty())
			throw new monException(cadre, Logo.messages.getString("retourne")
					+ " " + Logo.messages.getString("ne_renvoie_pas") + " "
					+ Interprete.nom.peek().toString());
		else
			throw new monException(cadre, Logo.messages
					.getString("erreur_retourne"));
	}

	void etiquette(String mot) {
		//	Graphics2D g = (Graphics2D) cadre.ardoise1.dessin.getGraphics();
		montrecacheTortue();
		double angle = Math.PI / 2 - cadre.tortue.angle;
		g.rotate(angle);
		g.setPaintMode();
		g.setColor(cadre.tortue.couleurcrayon);
		float x = (float) (cadre.tortue.corX * Math.cos(angle) + cadre.tortue.corY
				* Math.sin(angle));
		float y = (float) (-cadre.tortue.corX * Math.sin(angle) + cadre.tortue.corY
				* Math.cos(angle));
		g.setFont(Panneau_Police.fontes[Cadre.police_etiquette]
				.deriveFont((float) cadre.tortue.police));
		g.drawString(mot, x, y);
		g.rotate(-angle);		
		montrecacheTortue();
		if (Cadre.mode_classique) cadre.ardoise1.repaint();
	}
	void rafraichis(){ //Lorsqu'on change la taille de la zone de dessin
       g=(Graphics2D)cadre.ardoise1.dessin.getGraphics();
		if (Logo.qualite==1) cadre.primitive.g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
       graph=cadre.ardoise1.getGraphics();
		
	}
	void rafraichis_animation(){
		graph.setClip(0,0,Logo.largeur_dessin,Logo.hauteur_dessin);
		graph.drawImage(cadre.ardoise1.dessin, 0, 0, cadre);
	}
	void clip(int x,int y,int width,int height){
		Rectangle rec=new Rectangle(x,y,width,height);
		Rectangle rec1=cadre.jScrollPane1.getViewport().getViewRect();
		Rectangle inter=rec.intersection(rec1);
		if (inter.width>0&&inter.height>0){
			if (Cadre.mode_classique){
				graph.setClip(inter);
				graph.drawImage(cadre.ardoise1.dessin, 0, 0, cadre);
			}
		}
	} 
	
	
}